#include <stdlib.h>
#include <string.h>

#include "hwp.h"

#ifdef __STDC__
int block_menu(void)
#else
int block_menu()
#endif
{
	WINDOW *block_win;

	int inputch=0,pos=0,current_mark,line,row;

	save_file_buffer=file_buffer;

	block_win=newwin(8,14,1,60);

	mybox(block_win,8,14);

	wattron(block_win,A_REVERSE);

	mvwaddstr(block_win,1,1,"Set Mark");

	wattroff(block_win,A_REVERSE);

	mvwaddstr(block_win,2,1,"Clear Marks");

	mvwaddstr(block_win,3,1,"Cut Block");

	mvwaddstr(block_win,4,1,"Copy Block");

	mvwaddstr(block_win,5,1,"Delete Block");

	mvwaddstr(block_win,6,1,"Paste Block");

	keypad(block_win,TRUE);

	wmove(block_win,1,1);

	wrefresh(block_win);

	while(inputch!='\n'&&inputch!='\r'&&inputch!=27)
	{
		inputch=getch();

		switch(pos)
		{
			case 0:	mvwaddstr(block_win,1,1,"Set Mark");

				break;

			case 1: mvwaddstr(block_win,2,1,"Clear Marks");

				break;

			case 2: mvwaddstr(block_win,3,1,"Cut Block");

				break;

			case 3: mvwaddstr(block_win,4,1,"Copy Block");

				break;

			case 4: mvwaddstr(block_win,5,1,"Delete Block");

				break;

			case 5: mvwaddstr(block_win,6,1,"Paste Block");

				break;
		}

		switch(inputch)
		{
			case 12:	wrefresh(curscr);

					break;

			case KEY_DOWN:	pos++;

					break;

			case KEY_UP:	pos--;

					if(pos<0)
						pos+=6;

					break;

			case KEY_RIGHT:	werase(block_win);

					wrefresh(block_win);

					delwin(block_win);

					display_screen();

					return -1;

			case KEY_LEFT:	werase(block_win);

					wrefresh(block_win);

					delwin(block_win);

					display_screen();

					return -2;
		}

		pos=pos%6;

		wattron(block_win,A_REVERSE);

		switch(pos)
		{
			case 0:	mvwaddstr(block_win,1,1,"Set Mark");
				wmove(block_win,1,1);

				break;

			case 1: mvwaddstr(block_win,2,1,"Clear Marks");
				wmove(block_win,2,1);

				break;

			case 2: mvwaddstr(block_win,3,1,"Cut Block");
				wmove(block_win,3,1);

				break;

			case 3: mvwaddstr(block_win,4,1,"Copy Block");
				wmove(block_win,4,1);

				break;

			case 4: mvwaddstr(block_win,5,1,"Delete Block");
				wmove(block_win,5,1);

				break;

			case 5: mvwaddstr(block_win,6,1,"Paste Block");
				wmove(block_win,6,1);

				break;
		}

		wattroff(block_win,A_REVERSE);

		wrefresh(block_win);
	}

	werase(block_win);

	wrefresh(block_win);

	delwin(block_win);

	display_screen();

	if (inputch==27)
		return 0;

	attron(A_REVERSE);

	mvaddstr(0,0,"                                                                        F1:Help ");

	attroff(A_REVERSE);

	wrefresh(stdscr);

	current_mark=current_y+(current_page-1)*LINES_PER_PAGE;

	switch(pos)
	{
		case 0:	if (lowmark==-1)
			{
				int pos;

				lowmark=current_mark;

				for (highmark=current_mark+((line_spacing)?1:0);highmark<=current_mark+line_spacing&&highmark<numlines;highmark++)
				{
					for (pos=0;pos<LINE_LENGTH;pos++)
					{
						if (((char)file_buffer[highmark*LINE_LENGTH+pos])!=0&&((char)file_buffer[highmark*LINE_LENGTH+pos])!=' ')
							break;
					}

					if (pos<LINE_LENGTH)
						break;
				}

				highmark--;

				if (highmark<current_mark)
					highmark=current_mark;
			}
			else if (current_mark<lowmark)
			{
				for (highmark=lowmark+((line_spacing)?1:0);highmark<=lowmark+line_spacing&&highmark<numlines;highmark++)
				{
					for (pos=0;pos<LINE_LENGTH;pos++)
					{
						if (((char)file_buffer[highmark*LINE_LENGTH+pos])!=0&&((char)file_buffer[highmark*LINE_LENGTH+pos])!=' ')
							break;
					}

					if (pos<LINE_LENGTH)
						break;
				}

				highmark--;

				if (highmark<current_mark)
					highmark=current_mark;

				lowmark=current_mark;
			}
			else if (current_mark>lowmark)
			{
				for (highmark=current_mark+((line_spacing)?1:0);highmark<=current_mark+line_spacing&&highmark<numlines;highmark++)
				{
					for (pos=0;pos<LINE_LENGTH;pos++)
					{
						if (((char)file_buffer[highmark*LINE_LENGTH+pos])!=0&&((char)file_buffer[highmark*LINE_LENGTH+pos])!=' ')
							break;
					}

					if (pos<LINE_LENGTH)
						break;
				}

				highmark--;

				if (highmark<current_mark)
					highmark=current_mark;
			}

			display_screen();

			keephighmark=highmark;

			keeplowmark=lowmark;

			return 0;

		case 1:	highmark=lowmark=-1;

			display_screen();

			return 0;

		case 3:	if (lowmark==-1)
			{
				error_message("Can't copy until block is marked.","Mark a block and try again.");

				return 0;
			}

			if (cut_buffer!=NULL)
				free(cut_buffer);

			cut_buffer=(short *)malloc((highmark+1-lowmark)*LINE_LENGTH*sizeof(short));

			if (cut_buffer==NULL)
			{
				error_message("Malloc error on cut buffer:","Did not cut.");

				return 0;
			}
			else
			{
				for (line=lowmark;line<=highmark;line++)
				{
					memcpy(cut_buffer+(line-lowmark)*LINE_LENGTH,file_buffer+line*LINE_LENGTH,LINE_LENGTH*sizeof(short));
				}
			}

			lowmark=highmark=-1;

			display_screen();

			return 0;

		case 2:	if (lowmark==-1)
			{
				error_message("Can't cut until block is marked.","Mark a block and try again.");

				return 0;
			}

			if (cut_buffer!=NULL)
				free(cut_buffer);

			cut_buffer=(short *)malloc((highmark+1-lowmark)*LINE_LENGTH*sizeof(short));

			if (cut_buffer==NULL)
			{
				error_message("Malloc error on cut buffer:","Did not cut.");

				return 0;
			}
			else
			{
				for (line=lowmark;line<=highmark;line++)
				{
					memcpy(cut_buffer+(line-lowmark)*LINE_LENGTH,file_buffer+line*LINE_LENGTH,LINE_LENGTH*sizeof(short));
				}
			}

		case 4:	if (lowmark==-1)
			{
				error_message("Can't delete until block is marked.","Mark a block and try again.");

				return 0;
			}

			current_y=lowmark%LINES_PER_PAGE;

			current_page=lowmark/LINES_PER_PAGE+1;

			for (line=highmark+1;line<numlines;line++)
				memcpy(file_buffer+(line-(highmark+1-lowmark))*LINE_LENGTH,file_buffer+line*LINE_LENGTH,LINE_LENGTH*sizeof(short));

			for (line=numlines-(highmark-lowmark+1);line<numlines;line++)
				memset(file_buffer+line*LINE_LENGTH,0,LINE_LENGTH*sizeof(short));

#if 1
			numlines-=highmark-lowmark+1;

			file_buffer=(short *)realloc(file_buffer,numlines*LINE_LENGTH*sizeof(short));

			if (file_buffer==NULL)
				my_exit("Malloc error deleting block.\n");
#endif

			lowmark=highmark=-1;

			changed=1;

			display_screen();

			return 0;

		case 5:	if (cut_buffer==NULL||keephighmark==-1||keeplowmark==-1)
			{
				error_message("Can't paste buffer because:","You haven't cut or copied one yet.");

				return 0;
			}

			file_buffer=(short *) realloc(file_buffer,(numlines+keephighmark+1-keeplowmark)*LINE_LENGTH*sizeof(short));

			if (file_buffer==NULL)
			{
				error_message("Realloc error on file buffer:","Did not paste.");

				file_buffer=save_file_buffer;

				return 0;
			}

			for (row=numlines+keephighmark-keeplowmark;row>=current_y+keephighmark+1-keeplowmark+(current_page-1)*LINES_PER_PAGE;row--)
				memcpy(file_buffer+row*LINE_LENGTH,file_buffer+(row-(keephighmark+1-keeplowmark))*LINE_LENGTH,LINE_LENGTH*sizeof(short));

			memset(file_buffer+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,0,(keephighmark+1-keeplowmark)*LINE_LENGTH*sizeof(short));

			for (line=current_y+(current_page-1)*LINES_PER_PAGE;line<=current_y+(current_page-1)*LINES_PER_PAGE+keephighmark-keeplowmark;line++)
				memcpy(file_buffer+line*LINE_LENGTH,cut_buffer+(line-(current_y+(current_page-1)*LINES_PER_PAGE))*LINE_LENGTH,LINE_LENGTH*sizeof(short));

			numlines+=keephighmark+1-keeplowmark;

			display_screen();

			changed++;

			return 0;
	}

	return 0;
}
