#ifdef OLD_ACCESS
#include <access.h>
#else
#include <unistd.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>

#include "hwp.h"

#ifdef __STDC__
void bring_in_file(void)
#else
void bring_in_file()
#endif
{
	static char input_filename[75]="";

	int retval;

	input_filename[68]=0;

	retval=get_inputline("Enter filename to bring in:",input_filename,input_filename);

	if (retval!=1)
	{
		int retval;

		retval=do_bring_in_file(input_filename);

		if (retval==0)
		{
			error_message("Unable to bring in:",input_filename);
		}
		else if (retval==-1)
		{
			error_message("Incorrect hwp version:",input_filename);
		}
		else if (retval==-2)
		{
			error_message("Realloc error while bring in file:","Try to save original file.");
		}
	}
}

#ifdef __STDC__
int do_bring_in_file(char *input_filename)
#else
int do_bring_in_file(input_filename)
char *input_filename;
#endif
{
	int current_file_fd,bringnumlines,row;

	char dummy_header[LINE_LENGTH+1],dummy_footer[LINE_LENGTH+1];

	FILE *current_file;

	save_file_buffer=file_buffer;

#ifdef OLD_ACCESS
	if (!access(input_filename,AEXISTS))
#else
	if (!access(input_filename,F_OK))
#endif
	{
#ifdef OLD_ACCESS
		if (!access(input_filename,AREAD))
#else
		if (!access(input_filename,R_OK))
#endif
		{
			if (strstr(input_filename,".hwp"))
			{
				int setup[25],swap_bytes=0;

				current_file_fd=open(input_filename,O_RDONLY);

				read(current_file_fd,setup,25*sizeof(int));

				/* setup[0] is the version number 
				   - 3 means that the special characters are
				   stored for each key
				   - versions 2 and 1 stored start and stop 
				   keys instead and must be converted
				   - 2 means that the header and footer are 
				   stored within the file 
				   - version 1 did not store them */

				if (setup[0]>3||setup[0]<1)
				{
					int item,p1,p2,p3,p4;

					swap_bytes=1;

					for (item=0;item<25;item++)
					{
						p1=(setup[item]&0xff000000)>>24;
						p2=(setup[item]&0x00ff0000)>>8;
						p3=(setup[item]&0x0000ff00)<<8;
						p4=(setup[item]&0x000000ff)<<24;

						setup[item]=p1|p2|p3|p4;
					}
				}

				if (setup[0]>3||setup[0]<1)
					return -1;
				else if (setup[0]>=2)
				{
					read(current_file_fd,dummy_header,LINE_LENGTH+1);
					read(current_file_fd,dummy_footer,LINE_LENGTH+1);
				}

				bringnumlines=setup[1];

				if (!bringnumlines)
					return 0;

				file_buffer=(short *) realloc(file_buffer,(numlines+bringnumlines)*LINE_LENGTH*sizeof(short));

				if (file_buffer==NULL)
				{
					file_buffer=save_file_buffer;
					return -2;
				}

				for (row=numlines+bringnumlines-1;row>=current_y+bringnumlines+(current_page-1)*LINES_PER_PAGE;row--)
					memcpy(file_buffer+row*LINE_LENGTH,file_buffer+(row-bringnumlines)*LINE_LENGTH,LINE_LENGTH*sizeof(short));

				memset(file_buffer+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,0,bringnumlines*LINE_LENGTH*sizeof(short));

				read(current_file_fd,file_buffer+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,bringnumlines*LINE_LENGTH*sizeof(short));

				close(current_file_fd);

				if (swap_bytes)
				{
					short p1,p2,count;

					for (count=(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH;count<(current_y+bringnumlines+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH;count++)
					{
						p1=(file_buffer[count]&0xff00)>>8;
						p2=(file_buffer[count]&0x00ff)<<8;
						file_buffer[count]=p1|p2;
					}
				}

				if (setup[0]<3)
				{
					int line,pos;

					for (line=current_y+(current_page-1)*LINES_PER_PAGE;line<current_y+bringnumlines+(current_page-1)*LINES_PER_PAGE;line++)
					{
						current_attr=0;

						for (pos=0;pos<LINE_LENGTH;pos++)
						{
							if (file_buffer[line*LINE_LENGTH+pos]&START_BOLD)
								current_attr|=START_BOLD;

							if (file_buffer[line*LINE_LENGTH+pos]&END_BOLD)
								current_attr&=~START_BOLD;

							if (file_buffer[line*LINE_LENGTH+pos]&START_UNDERLINE)
								current_attr|=START_UNDERLINE;

							if (file_buffer[line*LINE_LENGTH+pos]&END_UNDERLINE)
								current_attr&=~START_UNDERLINE;

							if (file_buffer[line*LINE_LENGTH+pos]&START_SUPERSCRIPT)
								current_attr|=START_SUPERSCRIPT;

							if (file_buffer[line*LINE_LENGTH+pos]&END_SUPERSCRIPT)
								current_attr&=~START_SUPERSCRIPT;

							if (file_buffer[line*LINE_LENGTH+pos]&START_SUBSCRIPT)
								current_attr|=START_SUBSCRIPT;

							if (file_buffer[line*LINE_LENGTH+pos]&END_SUBSCRIPT)
								current_attr&=~START_SUBSCRIPT;

							file_buffer[line*LINE_LENGTH+pos]|=current_attr;
						}
					}
				}
			}
			else
			{
				int line;

				char tmpfilename[65],command[128];

				sprintf(tmpfilename,"/tmp/hwp.%d",getpid());

				sprintf(command,"%s < %s > %s",UNTABER,input_filename,tmpfilename);

				system(command);

				current_file=fopen(tmpfilename,"r");

				bringnumlines=0;

				while (fgets(inputline,LINE_LENGTH-(left_margin+1),current_file))
					bringnumlines++;

				if (!bringnumlines)
					return 0;

				rewind(current_file);

				file_buffer=(short *) realloc(file_buffer,(bringnumlines+numlines)*LINE_LENGTH*sizeof(short));

				if (file_buffer==NULL)
				{
					fclose(current_file);

					unlink(tmpfilename);

					file_buffer=save_file_buffer;

					return -2;
				}

				for (row=numlines+bringnumlines-1;row>=current_y+bringnumlines+(current_page-1)*LINES_PER_PAGE;row--)
					memcpy(file_buffer+row*LINE_LENGTH,file_buffer+(row-bringnumlines)*LINE_LENGTH,LINE_LENGTH*sizeof(short));

				memset(file_buffer+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,0,bringnumlines*LINE_LENGTH*sizeof(short));

				for (line=0;line<bringnumlines;line++)
				{
					int pos;

					char *tmpptr;

					fgets(inputline,LINE_LENGTH-(left_margin+1),current_file);

					tmpptr=strrchr(inputline,'\n');

					if (tmpptr)
						*tmpptr=0;

					tmpptr=strrchr(inputline,'\r');

					if (tmpptr)
						*tmpptr=0;

				 	for (pos=0;pos<LINE_LENGTH-(left_margin+1);pos++)
					{
						if (pos<strlen(inputline))
							file_buffer[left_margin+pos+(line+current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]=(short)inputline[pos];
						else
							file_buffer[left_margin+pos+(line+current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]=0;
					}
				}

				fclose(current_file);

				unlink(tmpfilename);
			}
		}
		else 
			return 0;
	}
	else
		return 0;

	numlines+=bringnumlines;

	changed=1;

	return 1;
}
