#include <string.h>
#include <stdlib.h>

#include "hwp.h"

#ifdef __STDC__
void init_curses(void)
#else
void init_curses()
#endif
{
	char *termstr;

	termstr=getenv("TERM");

	if (strstr(termstr,"xterm"))
		term_type=X11;
	else if (strstr(termstr,"mgr"))
		term_type=MGR;

	if (term_type==GLASS)
		underline_char=A_REVERSE|A_BOLD;

	/* Initialize curses */

	mystdscr=initscr();

	if (mystdscr==NULL)
	{
		fputs("Error in initscr.\n",stderr);

		exit(1);
	}

	noecho();

	raw();

	nonl();

	keypad(mystdscr,TRUE);

	refresh();
}

#ifdef __STDC__
void end_curses(void)
#else
void end_curses()
#endif
{
	/* reset terminal after curses */

	nocbreak();

	echo();

	nl();

	erase();

	refresh();

	endwin();
}
