#include <string.h>
#include <ctype.h>

#include "hwp.h"
#include "keybind.h"

#ifdef __STDC__
int get_inputline(char *message,char *prompt,char *output)
#else
int get_inputline(message,prompt,output)
char *message,*prompt,*output;
#endif
{
	WINDOW *message_win;

	char tmpstr[69];

	int inputch=0,pos=0;

	memset(output+strlen(output),' ',((unsigned)68-strlen(output)));

	if (output!=prompt)
		memset(prompt+strlen(prompt),' ',((unsigned)68-strlen(prompt)));

	output[68]=0;

	message_win=newwin(7,70,10,5);

	keypad(message_win,TRUE);

	mvwaddstr(message_win,1,1,message);

	mybox(message_win,7,70);

	wattron(message_win,A_REVERSE);

	mvwaddstr(message_win,3,1,prompt);

	wattroff(message_win,A_REVERSE);

	mvwaddstr(message_win,5,25,"CTRL-C to Cancel");

	wmove(message_win,3,1);

	wrefresh(message_win);

	wattron(message_win,A_REVERSE);

	while(inputch!='\n'&&inputch!='\r'&&inputch!=3)
	{
		inputch=wgetch(message_win);

		switch(inputch)
		{
		case HOT_REFRESH:	wrefresh(curscr);

					break;

		case HOT_INSERT:
		case KEY_IC:	insertmode=(insertmode==INSERT)?OVERSTRIKE:INSERT;

				attron(A_REVERSE);

				mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

				if (insertmode==OVERSTRIKE)
					mvprintw(LINES-2,69,"Overstrike");
				else
					mvprintw(LINES-2,69,"Insert    ");

				if (current_attr&START_BOLD)
					mvprintw(LINES-2,64,"Bold");
				else
					mvprintw(LINES-2,64,"    ");
		
				if (current_attr&START_UNDERLINE)
					mvprintw(LINES-2,54,"Underline");
				else
					mvprintw(LINES-2,54,"         ");

				attroff(A_REVERSE);

				refresh();

				wmove(message_win,3,pos+1);

				wrefresh(message_win);

				break;

		case KEY_LEFT:	if (pos>0)
				{
					pos--;

					wmove(message_win,3,pos+1);

					wrefresh(message_win);
				}

				break;

		case KEY_RIGHT:	if (pos<67)
				{
					pos++;

					wmove(message_win,3,pos+1);

					wrefresh(message_win);
				}

				break;

		case BIND_DELETE:
				{
					int pos1;

					for (pos1=pos;pos1<68;pos1++)
						output[pos1]=output[pos1+1];
				}

				mvwaddstr(message_win,3,1,output);

				wmove(message_win,3,pos+1);

				wrefresh(message_win);

				break;

		case BIND_BACKSPACE:
				{
					int pos1;

					for (pos1=pos-1;pos1<68;pos1++)
						output[pos1]=output[pos1+1];
				}

				mvwaddstr(message_win,3,1,output);

				pos--;

				wmove(message_win,3,pos+1);

				wrefresh(message_win);

				break;

		case HOT_HOME:
		case KEY_HOME:	pos=0;

				wmove(message_win,3,pos+1);

				wrefresh(message_win);

				break;

#ifndef linux
		case 347:
#else
		case KEY_END:
#endif
		case HOT_END:
		case KEY_EOL:	for (pos=67;pos>=left_margin;pos--)
					if (output[pos]!=' '&&output[pos]!=0)
						break;

				if (pos!=0&&pos!=67)
					pos++;

				wmove(message_win,3,pos+1);

				wrefresh(message_win);

				break;
				
		case KEY_F(1):	wattroff(message_win,A_REVERSE);

				werase(message_win);

				wrefresh(message_win);

				do_help();

				mybox(message_win,7,70);

				mvwaddstr(message_win,1,1,message);

				wattron(message_win,A_REVERSE);

				mvwaddstr(message_win,3,1,output);

				wattroff(message_win,A_REVERSE);

				mvwaddstr(message_win,5,25,"CTRL-C to Cancel");

				wmove(message_win,3,1+pos);

				wrefresh(message_win);

				wattron(message_win,A_REVERSE);

				break;
		}

		if (isprint(0xff&inputch)&&!(inputch&0xff00))
		{
			if (insertmode==OVERSTRIKE)
			{
				output[pos]=inputch;

				waddch(message_win,inputch);

				if (pos<67)
					pos++;
				else
					beep();

				wmove(message_win,3,pos+1);

				wrefresh(message_win);
			}
			else
			{
				if (output[67]!=' '&&output[67]!=0)
					beep();
				else
				{
					int pos1;

					for (pos1=67;pos1>pos;pos1--)
						output[pos1]=output[pos1-1];

					output[pos]=inputch;

					if (pos<67)
						pos++;
					else
						beep();
	
					mvwaddstr(message_win,3,1,output);

					wmove(message_win,3,pos+1);
			
					wrefresh(message_win);
				}
			}
		}
	}

	wattroff(message_win,A_REVERSE);

	werase(message_win);

	wrefresh(message_win);

	delwin(message_win);

	display_screen();

	strcpy(tmpstr,output+strspn(output," "));

	for (pos=strlen(tmpstr)-1;pos>0;pos--)
		if (tmpstr[pos]==' ')
			tmpstr[pos]=0;
		else
			break;

	strcpy(output,tmpstr);

	if (inputch==3)
		return -1;
	else
		return 0;
}
