#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "hwp.h"
#include "keybind.h"

#ifdef __STDC__
void get_user_input(void)
#else
void get_user_input()
#endif
{
	int quitting=0,inputch,line,row,current_mark,pos;

	attron(A_REVERSE);

	mvaddstr(0,0," F2:File    F3:Etc.    F4:Locate    F5:Options    F6:Spell   F7:Block   F1:Help ");

	mvaddstr(LINES-2,0,"                                                                                 ");
	mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

	if (insertmode==OVERSTRIKE)
		mvprintw(LINES-2,69,"Overstrike");
	else
		mvprintw(LINES-2,69,"Insert    ");

	if (current_attr&START_BOLD)
		mvprintw(LINES-2,64,"Bold");
	else
		mvprintw(LINES-2,64,"    ");
		
	if (current_attr&START_UNDERLINE)
		mvprintw(LINES-2,54,"Underline");
	else
		mvprintw(LINES-2,54,"         ");

	attroff(A_REVERSE);

	attron(A_BOLD);

	mvaddstr(LINES-1,0," Press function key to activate menu.  Or press F10 to activate menu bar.      ");

	attroff(A_BOLD);

	refresh();

	display_screen();

	while (!quitting)
	{
		inputch=wgetch(textscr);

		switch(inputch)
		{
		/* save file */
		case HOT_SAVE:		write_file();

					break;

		/* find next */
		case HOT_SEARCH:	if (strlen(search_str)==0)
					{
						error_message("Can't find next because:","You haven't specified a search string yet.");
		
						break;
					}

					do_search(search_str,find_type,0);

					attron(A_REVERSE);
				
					mvaddstr(LINES-2,0,"                                                                                 ");
					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);
				
					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
				
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
						
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");
				
					attroff(A_REVERSE);

					attron(A_BOLD);
				
					mvaddstr(LINES-1,0," Press function key to activate menu.  Or press F10 to activate menu bar.      ");
				
					attroff(A_BOLD);

					refresh();

					display_screen();

					break;

		/* replace next */
		case HOT_REPLACE:	if (strlen(replace_str)==0)
					{
						error_message("Can't replace next because:","You haven't specified a search/replace pair yet.");
		
						break;
					}

					do_replace(search_str,replace_str,0);

					attron(A_REVERSE);
				
					mvaddstr(LINES-2,0,"                                                                                 ");
					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);
				
					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
				
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
						
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");
				
					attroff(A_REVERSE);

					attron(A_BOLD);
				
					mvaddstr(LINES-1,0," Press function key to activate menu.  Or press F10 to activate menu bar.      ");
				
					attroff(A_BOLD);

					refresh();

					display_screen();
				
					break;

		/* skip current word */
		case HOT_SKIP: 		current_word++;

					last_page=last_x=last_y=-1;

					last_current_x=current_x;
					current_x=left_margin-1;

				/* next incorrect word */
		case HOT_NEXT:		if (num_words<0)
					{
#if 0
						current_x=last_current_x;
#endif
						error_message("Can't get next incorrect word because:","You haven't checked the spelling yet.");
		
						break;
					}
		
					if (current_word>=num_words)
					{
						current_x=last_current_x;
						error_message("Can't get next incorrect word because:","All words have been checked.");
		
						break;
					}
		
					while (1)
					{
						if (do_search(word_list[current_word],CASE_LEN,-1)==0)
						{
							current_word++;
		
							last_current_x=current_x;
							current_x=left_margin-1;
		
							last_page=last_x=last_y=-1;
		
							if (current_word>=num_words)
							{
								current_x=last_current_x;
								error_message("Can't get next incorrect word because:","All words have been checked.");
			
								break;
							}
						}
						else
						{
							if (last_x==-1)
							{
								last_x=current_x;
				
								last_y=current_y;
				
								last_page=current_page;
		
								break;
							}
							else if (last_x==current_x&&last_y==current_y&&last_page==current_page)
							{
								last_page=last_x=last_y=-1;
		
								current_word++;
		
								last_current_x=current_x;
								current_x=left_margin-1;
		
								if (current_word>=num_words)
								{
									current_x=last_current_x;
									error_message("Can't get next incorrect word because:","All words have been checked.");
				
									break;
								}
							}
							else
								break;
						}
					}
		
					display_screen();
		
					break;
		/* quit */
		case HOT_QUIT:		if (confirm_quit())
						quitting++;

					break;
		/* cut */
		case HOT_CUT:		if (lowmark==-1)
					{
						error_message("Can't cut until block is marked.","Mark a block and try again.");
		
						break;
					}
		
					if (cut_buffer!=NULL)
						free(cut_buffer);
		
					cut_buffer=(short *)malloc((highmark+1-lowmark)*LINE_LENGTH*sizeof(short));
		
					if (cut_buffer==NULL)
					{
						error_message("Malloc error on cut buffer:","Did not cut.");
		
						break;
					}
					else
					{
						for (line=lowmark;line<=highmark;line++)
						{
							memcpy(cut_buffer+(line-lowmark)*LINE_LENGTH,file_buffer+line*LINE_LENGTH,LINE_LENGTH*sizeof(short));
						}
					}
		/* delete */
		case HOT_DELETE:	if (lowmark==-1)
					{
						error_message("Can't delete until block is marked.","Mark a block and try again.");
		
						break;
					}
		
					current_y=lowmark%LINES_PER_PAGE;
		
					current_page=lowmark/LINES_PER_PAGE+1;
		
					for (line=highmark+1;line<numlines;line++)
						memcpy(file_buffer+(line-(highmark+1-lowmark))*LINE_LENGTH,file_buffer+line*LINE_LENGTH,LINE_LENGTH*sizeof(short));

					for (line=numlines-(highmark-lowmark+1);line<numlines;line++)
						memset(file_buffer+line*LINE_LENGTH,0,LINE_LENGTH*sizeof(short));

#if 1
					numlines-=highmark-lowmark+1;
		
					file_buffer=(short *)realloc(file_buffer,numlines*LINE_LENGTH*sizeof(short));
		
					if (file_buffer==NULL)
						my_exit("Malloc error deleting block.\n");
#endif
		
					lowmark=highmark=-1;
		
					changed=1;
		
					display_screen();
		
					break;
		/* paste */
		case HOT_PASTE:		save_file_buffer=file_buffer;

					if (cut_buffer==NULL||keephighmark==-1||keeplowmark==-1)
					{
						error_message("Can't paste buffer because:","You haven't cut or copied one yet.");
		
						break;
					}
		
					file_buffer=(short *) realloc(file_buffer,(numlines+keephighmark+1-keeplowmark)*LINE_LENGTH*sizeof(short));
		
					if (file_buffer==NULL)
					{
						error_message("Realloc error on file buffer:","Did not paste.");
		
						file_buffer=save_file_buffer;
		
						break;
					}
		
					for (row=numlines+keephighmark-keeplowmark;row>=current_y+keephighmark+1-keeplowmark+(current_page-1)*LINES_PER_PAGE;row--)
						memcpy(file_buffer+row*LINE_LENGTH,file_buffer+(row-(keephighmark+1-keeplowmark))*LINE_LENGTH,LINE_LENGTH*sizeof(short));
		
					memset(file_buffer+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,0,(keephighmark+1-keeplowmark)*LINE_LENGTH*sizeof(short));
		
					for (line=current_y+(current_page-1)*LINES_PER_PAGE;line<=current_y+(current_page-1)*LINES_PER_PAGE+keephighmark-keeplowmark;line++)
						memcpy(file_buffer+line*LINE_LENGTH,cut_buffer+(line-(current_y+(current_page-1)*LINES_PER_PAGE))*LINE_LENGTH,LINE_LENGTH*sizeof(short));
		
					numlines+=keephighmark+1-keeplowmark;
		
					display_screen();
		
					changed++;
		
					break;
		/* mark */
		case HOT_MARK:		current_mark=current_y+(current_page-1)*LINES_PER_PAGE;
		
					if (lowmark==-1)
					{
						int pos;
		
						lowmark=current_mark;
		
						for (highmark=current_mark+((line_spacing)?1:0);highmark<=current_mark+line_spacing&&highmark<numlines;highmark++)
						{
							for (pos=0;pos<LINE_LENGTH;pos++)
							{
								if (((char)file_buffer[highmark*LINE_LENGTH+pos])!=0&&((char)file_buffer[highmark*LINE_LENGTH+pos])!=' ')
									break;
							}
		
							if (pos<LINE_LENGTH)
								break;
						}
		
						highmark--;
		
						if (highmark<current_mark)
							highmark=current_mark;
					}
					else if (current_mark<lowmark)
					{
						for (highmark=lowmark+((line_spacing)?1:0);highmark<=lowmark+line_spacing&&highmark<numlines;highmark++)
						{
							for (pos=0;pos<LINE_LENGTH;pos++)
							{
								if (((char)file_buffer[highmark*LINE_LENGTH+pos])!=0&&((char)file_buffer[highmark*LINE_LENGTH+pos])!=' ')
									break;
							}
		
							if (pos<LINE_LENGTH)
								break;
						}
		
						highmark--;
		
						if (highmark<current_mark)
							highmark=current_mark;
		
						lowmark=current_mark;
					}
					else if (current_mark>lowmark)
					{
						for (highmark=current_mark+((line_spacing)?1:0);highmark<=current_mark+line_spacing&&highmark<numlines;highmark++)
						{
							for (pos=0;pos<LINE_LENGTH;pos++)
							{
								if (((char)file_buffer[highmark*LINE_LENGTH+pos])!=0&&((char)file_buffer[highmark*LINE_LENGTH+pos])!=' ')
									break;
							}
		
							if (pos<LINE_LENGTH)
								break;
						}
		
						highmark--;
		
						if (highmark<current_mark)
							highmark=current_mark;
					}
		
					display_screen();
		
					keephighmark=highmark;
		
					keeplowmark=lowmark;
		
					break;
		/* copy */
		case HOT_COPY:		if (lowmark==-1)
					{
						error_message("Can't copy until block is marked.","Mark a block and try again.");
		
						break;
					}
		
					if (cut_buffer!=NULL)
						free(cut_buffer);
		
					cut_buffer=(short *)malloc((highmark+1-lowmark)*LINE_LENGTH*sizeof(short));
		
					if (cut_buffer==NULL)
					{
						error_message("Malloc error on cut buffer:","Did not cut.");
		
						break;
					}
					else
					{
						for (line=lowmark;line<=highmark;line++)
						{
							memcpy(cut_buffer+(line-lowmark)*LINE_LENGTH,file_buffer+line*LINE_LENGTH,LINE_LENGTH*sizeof(short));
						}
					}
		
					lowmark=highmark=-1;
		
					display_screen();
		
					break;
		/* toggle underline */
		case HOT_UNDERLINE:	if (current_attr&START_UNDERLINE)
						current_attr&=~START_UNDERLINE;
					else
						current_attr|=START_UNDERLINE;
	
					attron(A_REVERSE);

					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
	
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
			
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");
	
					attroff(A_REVERSE);
	
					wmove(textscr,current_y,current_x);
	
					wrefresh(stdscr);
					wrefresh(textscr);
	
					break;

		/* toggle bold */
		case HOT_BOLD:		if (current_attr&START_BOLD)
						current_attr&=~START_BOLD;
		  			else
						current_attr|=START_BOLD;
		
						attron(A_REVERSE);
		
						mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);
		
						if (insertmode==OVERSTRIKE)
							mvprintw(LINES-2,69,"Overstrike");
						else
							mvprintw(LINES-2,69,"Insert    ");
		
						if (current_attr&START_BOLD)
							mvprintw(LINES-2,64,"Bold");
						else
							mvprintw(LINES-2,64,"    ");
				
						if (current_attr&START_UNDERLINE)
							mvprintw(LINES-2,54,"Underline");
						else
							mvprintw(LINES-2,54,"         ");
		
						attroff(A_REVERSE);
		
						wmove(textscr,current_y,current_x);
		
						wrefresh(stdscr);
						wrefresh(textscr);
		
						break;

		case HOT_REFRESH:		wrefresh(curscr);

						break;

		case HOT_INSERT:
		case KEY_IC:	insertmode=(insertmode==INSERT)?OVERSTRIKE:INSERT;

				attron(A_REVERSE);

				mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

				if (insertmode==OVERSTRIKE)
					mvprintw(LINES-2,69,"Overstrike");
				else
					mvprintw(LINES-2,69,"Insert    ");

				if (current_attr&START_BOLD)
					mvprintw(LINES-2,64,"Bold");
				else
					mvprintw(LINES-2,64,"    ");
		
				if (current_attr&START_UNDERLINE)
					mvprintw(LINES-2,54,"Underline");
				else
					mvprintw(LINES-2,54,"         ");

				attroff(A_REVERSE);

				refresh();

				wmove(textscr,current_y,current_x);

				wrefresh(textscr);

				break;

		case KEY_F(1):
		case KEY_F(2):
		case KEY_F(3):
		case KEY_F(4):
		case KEY_F(5):
		case KEY_F(6):
		case KEY_F(7):
				attron(A_BOLD);

				mvaddstr(LINES-1,0," Use the arrow keys to move within a menu or to move to another menu.     ");

				attroff(A_BOLD);

				wrefresh(stdscr);

				switch(inputch)
				{
					case KEY_F(1):	do_help();

							break;

					case KEY_F(2):	if (file_menu()==1)
								quitting++;

							break;

					case KEY_F(3):	edit_menu();

							break;

					case KEY_F(4):	locate_menu();

							break;

					case KEY_F(5):	options_menu();

							break;

					case KEY_F(6):	spell_menu();

							break;

					case KEY_F(7):	block_menu();

							break;
				}

				attron(A_REVERSE);

				mvaddstr(0,0," F2:File    F3:Etc.    F4:Locate    F5:Options    F6:Spell   F7:Block   F1:Help ");

				mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

				if (insertmode==OVERSTRIKE)
					mvprintw(LINES-2,69,"Overstrike");
				else
					mvprintw(LINES-2,69,"Insert    ");

				if (current_attr&START_BOLD)
					mvprintw(LINES-2,64,"Bold");
				else
					mvprintw(LINES-2,64,"    ");
		
				if (current_attr&START_UNDERLINE)
					mvprintw(LINES-2,54,"Underline");
				else
					mvprintw(LINES-2,54,"         ");

				attroff(A_REVERSE);

				attron(A_BOLD);

				mvaddstr(LINES-1,0," Press function key to activate menu.  Or press F10 to activate menu bar.      ");

				attroff(A_BOLD);

				wmove(textscr,current_y,current_x);

				wrefresh(stdscr);
				wrefresh(textscr);

				break;
		
		case 27:
		case KEY_F(10): attron(A_BOLD);

				mvaddstr(LINES-1,0," Use the arrow keys to move within the menubar; Enter to select, Esc to exit.");

				attroff(A_BOLD);

				wrefresh(stdscr);

				if (do_menubar()==1)
					quitting++;

				attron(A_REVERSE);

				mvaddstr(0,0," F2:File    F3:Etc.    F4:Locate    F5:Options    F6:Spell   F7:Block   F1:Help ");

				mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

				if (insertmode==OVERSTRIKE)
					mvprintw(LINES-2,69,"Overstrike");
				else
					mvprintw(LINES-2,69,"Insert    ");

				if (current_attr&START_BOLD)
					mvprintw(LINES-2,64,"Bold");
				else
					mvprintw(LINES-2,64,"    ");
		
				if (current_attr&START_UNDERLINE)
					mvprintw(LINES-2,54,"Underline");
				else
					mvprintw(LINES-2,54,"         ");

				attroff(A_REVERSE);

				attron(A_BOLD);

				mvaddstr(LINES-1,0," Press function key to activate menu.  Or press F10 to activate menu bar.      ");

				attroff(A_BOLD);

				wmove(textscr,current_y,current_x);

				wrefresh(stdscr);
				wrefresh(textscr);

				break;

		case '\t':	if (insertmode==OVERSTRIKE)
				{
					if (current_x<indent)
						current_x=indent;
					else
					{
						if (current_x%tab_size==0)
							current_x+=tab_size;
						else
							for (;current_x%tab_size;current_x++);
					}

					wmove(textscr,current_y,current_x);

					wrefresh(textscr);
				}
				else
				{
					int new_x;

					short tmpstr[LINE_LENGTH];

					changed++;

					if (current_x<indent)
						new_x=indent;
					else
					{
						if (current_x%tab_size==0)
							new_x=current_x+tab_size;
						else
							for (new_x=current_x;new_x%tab_size;new_x++);
					}

					memset(tmpstr,0,((unsigned)LINE_LENGTH*2));

#if 0
					memset(tmpstr,' ',((unsigned)new_x-current_x));
#endif

					insert(tmpstr,new_x-current_x,current_y);

					current_x=new_x;

					display_screen();
				}

				break;

		case '\r':
		case '\n':	if (insertmode==INSERT)
				{
					int pos;

					changed++;

					numlines+=(1+line_spacing);
			
					file_buffer=(short *) realloc(file_buffer,numlines*LINE_LENGTH*sizeof(short));
							
					if (file_buffer==NULL)
						my_exit("Realloc error on file buffer.\n");
			
					memset(file_buffer+(numlines-(1+line_spacing))*LINE_LENGTH,0,((unsigned)(1+line_spacing)*LINE_LENGTH*sizeof(short)));
			
					if ((current_y+(current_page-1)*LINES_PER_PAGE+(1+line_spacing))<(numlines-(1+line_spacing)))
					{
						int line;

						for (line=numlines-1;line>=current_y+2+(current_page-1)*LINES_PER_PAGE;line--)
							memcpy(file_buffer+line*LINE_LENGTH,file_buffer+(line-(1+line_spacing))*LINE_LENGTH,LINE_LENGTH*sizeof(short));

						memset(file_buffer+(current_y+1+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,0,((unsigned)LINE_LENGTH*(1+line_spacing)*sizeof(short)));
					}

					for (pos=current_x;pos<=right_margin;pos++)
					{
						file_buffer[pos+left_margin-current_x+(current_y+(1+line_spacing)+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]=
								file_buffer[pos+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH];

						file_buffer[pos+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]=0;
					}

					display_screen();
				}

				current_x=right_margin;

		case KEY_RIGHT:	if (current_x<right_margin)
				{
					current_x++;

					wmove(textscr,current_y,current_x);

					wrefresh(textscr);

					break;
				}
				else
				{
					current_x=left_margin;
				}
		case KEY_DOWN:	if (current_y+(1+line_spacing)+((current_page-1)*LINES_PER_PAGE)>=numlines)
				{
					numlines+=line_spacing+1;
	
					file_buffer=(short *) realloc(file_buffer,numlines*LINE_LENGTH*sizeof(short));
				
					if (file_buffer==NULL)
						my_exit("Realloc error on file buffer.\n");

					memset(file_buffer+(numlines-(1+line_spacing))*LINE_LENGTH,0,((unsigned)(1+line_spacing)*LINE_LENGTH*sizeof(short)));
				}

				wattroff(textscr,A_BOLD);

				wattroff(textscr,underline_char);

				if (current_y<(LINES_PER_PAGE-(1+line_spacing)))
				{
					current_y=(current_y+1+line_spacing)%LINES_PER_PAGE;

					attron(A_REVERSE);

					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
	
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
			
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");

					attroff(A_REVERSE);

					refresh();

					wmove(textscr,current_y,current_x);

					wrefresh(textscr);

					break;
				}

		case KEY_NPAGE:	if ((current_page*LINES_PER_PAGE)<=numlines)
				{
					current_page++;

					wattroff(textscr,A_BOLD);

					wattroff(textscr,underline_char);

					if (inputch==KEY_NPAGE)
					{
						if (line_spacing>0)
							current_y=((current_page-1)*LINES_PER_PAGE)%(1+line_spacing);
						else
							current_y=0;
					}
					else
						current_y=(current_y+1+line_spacing)%LINES_PER_PAGE;

					attron(A_REVERSE);

					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
	
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
			
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");

					attroff(A_REVERSE);

					refresh();

					display_screen();
				}

				break;

		case BIND_DELETE:
				{
					int pos;

					changed++;

					for (pos=current_x;pos<right_margin;pos++)
						file_buffer[pos+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]=file_buffer[pos+1+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH];

					file_buffer[pos+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]=0;

					justify(current_y);
				}

				display_screen();

				break;

		case BIND_BACKSPACE:
				if (current_x<=left_margin&&(current_y!=0||current_page!=1))
				{
					int pos;

					for (pos=right_margin;pos>=left_margin;pos--)
						if (((char)file_buffer[pos+(current_y-(1+line_spacing)+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH])!=0&&((char)file_buffer[pos+(current_y-(1+line_spacing)+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH])!=' ')
							break;

					current_x=-(pos+1);
						
					changed++;

					justify(current_y-(1+line_spacing));
				}
				else if (current_x>left_margin)
				{
					int pos;

					changed++;

					for (pos=current_x-1;pos<right_margin;pos++)
						file_buffer[pos+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]=
							file_buffer[pos+1+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH];

					file_buffer[pos+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]=0;

					justify(current_y);
				}

				display_screen();

		case KEY_LEFT:	if (current_x>left_margin)
				{
					current_x--;

					wmove(textscr,current_y,current_x);

					wrefresh(textscr);

					break;
				}
				else if ((current_page>1||current_y!=0)&&current_x>=0)
				{
					current_x=right_margin;
				}
				else if (current_x<0)
					current_x=-(current_x);
				else
					break;

		case KEY_UP:	if ((line_spacing==0&&current_y>0)||(line_spacing>0&&current_y>(((current_page-1)*LINES_PER_PAGE))%(1+line_spacing)))
				{
					current_y=current_y-1-line_spacing;

					wattroff(textscr,A_BOLD);

					wattroff(textscr,underline_char);

					attron(A_REVERSE);

					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
	
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
			
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");

					attroff(A_REVERSE);

					refresh();

					wmove(textscr,current_y,current_x);

					wrefresh(textscr);

					break;
				}

		case KEY_PPAGE:	if (current_page>1)
				{
					current_page--;

					wattroff(textscr,A_BOLD);

					wattroff(textscr,underline_char);

					if (inputch==KEY_PPAGE)
					{
						if (line_spacing>0)
							current_y=((current_page)*LINES_PER_PAGE)%(1+line_spacing)-(1+line_spacing)+LINES_PER_PAGE;
#if 0
							current_y=LINES_PER_PAGE-1+((current_page-1)*LINES_PER_PAGE+1)%(1+line_spacing);
#endif
						else
							current_y=LINES_PER_PAGE-1;
					}
					else
						current_y=current_y-1-line_spacing;

					if (current_y<0)
						current_y+=LINES_PER_PAGE;

					attron(A_REVERSE);

					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
	
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
			
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");

					attroff(A_REVERSE);

					refresh();

					display_screen();
				}

				break;

		case HOT_HOME:
		case KEY_HOME:	current_x=left_margin;

				wmove(textscr,current_y,current_x);

				wrefresh(textscr);

				break;

#ifndef linux
		case 347:
#else
		case KEY_END:
#endif
		case HOT_END:
		case KEY_EOL:	for (current_x=right_margin;current_x>left_margin;current_x--)
				{
					if (((char)file_buffer[current_x+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH])!=' '&&((char)file_buffer[current_x+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH])!=0)
						break;
				}

				if (current_x<right_margin)
					current_x++;

				wmove(textscr,current_y,current_x);

				wrefresh(textscr);

				break;
		}

		if (isprint(0xff&inputch)&&!(inputch&0xff00))
		{
			short tempstr[LINE_LENGTH];

			int count=0,pos,word_wrap=0;

			changed++;

			if (insertmode==OVERSTRIKE)
			{
				file_buffer[current_x+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]=inputch|current_attr;

				wattron(textscr,A_NORMAL);

				if (current_attr&START_BOLD)
					wattron(textscr,A_BOLD);

				if (current_attr&START_UNDERLINE)
					wattron(textscr,underline_char);

				if (current_attr&START_SUPERSCRIPT)
					wattron(textscr,A_REVERSE);

				if (current_attr&START_SUBSCRIPT)
					wattron(textscr,A_REVERSE);

/* attr problem */

				waddch(textscr,inputch);

			 	if (current_x<right_margin)
				{
					current_x++;

					wmove(textscr,current_y,current_x);

					wrefresh(textscr);

					continue;
				}
				else
				{
					/* do word wrap */

					for (pos=current_x;pos>=left_margin;pos--)
					{
						if (((char)file_buffer[pos+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH])==' '||(((char)file_buffer[pos+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH])==0))
							break;

						count++;
					}

					count--;

					if (pos<left_margin||pos==current_x)
						current_x=left_margin;
					else
					/* wrap word */
					{
						word_wrap=1;

						memcpy(tempstr,file_buffer+current_x-count+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,(count+1)*sizeof(short));

						memset(file_buffer+current_x-count+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,0,((unsigned)(count+1)*sizeof(short)));

						current_x=left_margin+count+1;
					}
				}

				if (current_y+(1+line_spacing)+((current_page-1)*LINES_PER_PAGE)>=numlines)
				{
					numlines+=line_spacing+1;
	
					file_buffer=(short *) realloc(file_buffer,numlines*LINE_LENGTH*sizeof(short));
				
					if (file_buffer==NULL)
						my_exit("Realloc error on file buffer.\n");

					memset(file_buffer+(numlines-(1+line_spacing))*LINE_LENGTH,0,((unsigned)(1+line_spacing)*LINE_LENGTH*sizeof(short)));
				}

				if (current_y<(LINES_PER_PAGE-(1+line_spacing)))
				{
					current_y+=1+line_spacing;

					wattroff(textscr,A_BOLD);

					wattroff(textscr,underline_char);

					if (word_wrap)
					{
						memcpy(file_buffer+left_margin+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,tempstr,(count+1)*sizeof(short));
	
						display_screen();
					}

					attron(A_REVERSE);

					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
	
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
			
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");

					attroff(A_REVERSE);

					refresh();

					wmove(textscr,current_y,current_x);

					wrefresh(textscr);

					continue;
				}

				if ((current_page*LINES_PER_PAGE)<=numlines)
				{
					current_y=(current_y+1+line_spacing)%LINES_PER_PAGE;

					wattroff(textscr,A_BOLD);

					wattroff(textscr,underline_char);

					current_page++;

					if (word_wrap)
						memcpy(file_buffer+left_margin+(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH,tempstr,(count+1)*sizeof(short));

					attron(A_REVERSE);

					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
	
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
			
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");

					attroff(A_REVERSE);

					refresh();

					display_screen();
				}
			}
			else
			{
				/* build a string of one short which is the
				   character typed and the current attr; then
				   insert() that short, set the cursor position
				   appropriately and display the screen */

				tempstr[0]=inputch|current_attr;

				insert(tempstr,1,current_y);

				display_screen();

				if (current_x<0)
					current_x=-current_x;
				else if (current_x<=right_margin)
					continue;

				if (current_y<(LINES_PER_PAGE-(1+line_spacing)))
				{
					current_y+=1+line_spacing;

					wattroff(textscr,A_BOLD);

					wattroff(textscr,underline_char);

					attron(A_REVERSE);

					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
	
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
			
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");

					attroff(A_REVERSE);

					refresh();

					wmove(textscr,current_y,current_x);

					wrefresh(textscr);

					continue;
				}

				if ((current_page*LINES_PER_PAGE)<=numlines)
				{
					current_y=(current_y+1+line_spacing)%LINES_PER_PAGE;

					wattroff(textscr,A_BOLD);
	
					wattroff(textscr,underline_char);

					current_page++;

					attron(A_REVERSE);

					mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

					if (insertmode==OVERSTRIKE)
						mvprintw(LINES-2,69,"Overstrike");
					else
						mvprintw(LINES-2,69,"Insert    ");
	
					if (current_attr&START_BOLD)
						mvprintw(LINES-2,64,"Bold");
					else
						mvprintw(LINES-2,64,"    ");
			
					if (current_attr&START_UNDERLINE)
						mvprintw(LINES-2,54,"Underline");
					else
						mvprintw(LINES-2,54,"         ");

					attroff(A_REVERSE);

					refresh();

					display_screen();
				}
			}
		}
	}
}
