/* Harry's Word Processor v1.4.10 */

/* Copyright 1993, 1994, Harry C. Pulley, IV.  Permission granted to copy hwp 
   or modify it in any form so long as my name and copyright remains in place.
   I am not responsible for any damages caused by the program in any way, 
   shape or form. 

   If you make any changes or have any bug reports to make, please send them to
   hpulley@uoguelph.ca. */

/* Header files */

#include <stdlib.h>
#include <string.h>

#include "hwp.h"

/* Globals */

int underline_char=A_UNDERLINE;

int term_type=GLASS;

char **word_list=NULL;

int highmark=-1,lowmark=-1;

int num_words=-1;

int elm=0;

int last_current_x,current_word=-1,last_x=-1,last_y=-1,last_page=-1;

int find_type=0;

char search_str[LINE_LENGTH+1]="",replace_str[LINE_LENGTH+1]="";

short *save_file_buffer;

short *file_buffer=NULL;

short *cut_buffer=NULL;

int keephighmark=-1,keeplowmark=-1;

WINDOW *mystdscr,*textscr;

char filename[1024]="untitled.hwp",inputline[LINE_LENGTH+2]="";

int numlines=0,page_length=66,tab_size=8,indent=16,
	left_margin=8,right_margin=72,top_blanks=5,
	bottom_blanks=5,starting_page_no=1,version=3,
	current_page=1,current_y=0,current_x=16,current_attr=NORMAL,
	insertmode=INSERT,line_spacing=1,changed=0;

char header[LINE_LENGTH+1]="%",footer[LINE_LENGTH+1]="";

#ifdef __STDC__
int main(int argc,char **argv)
#else
int main(argc,argv)
int argc;
char **argv;
#endif
{
	int retval;

	/* For now, only allow a single file can be edited; if none is given 
	   then call it 'untitled.hwp' */

	if (argc==3)
	{
		if (!strcmp(argv[1],"-elm"))
		{
			strcpy(filename,argv[2]);

			elm=1;
		}
		else
		{
			fprintf(stderr,"Usage: %s [-elm] <filename>\n",argv[0]);
	
			exit(1);
		}
	}
	else if (argc==2)
		strcpy(filename,argv[1]);
	else if (argc>3)
	{
		fprintf(stderr,"Usage: %s [-elm] <filename>.\n",argv[0]);

		exit(1);
	}

	retval=do_load_file(filename);

	if (retval==0)
	{
		fprintf(stderr,"Unable to load %s\n",filename);

		exit(1);
	}
	else if (retval==-1)
	{
		fprintf(stderr,"Incorrect version of hwp in file %s\n",filename);

		exit(2);
	}

	if (term_type==MGR)
		puts("\0334h");

	init_curses();

	textscr=newwin(LINES_PER_PAGE,80,1,0);

	keypad(textscr,TRUE);

	get_user_input();

	end_curses();

#ifdef MGR
	puts("\033h");
#endif

	return 0;
}

#ifdef __STDC__
void my_exit(char *message)
#else
void my_exit(message)
char *message;
#endif
{
	erase();

	refresh();

	end_curses();

	fputs(message,stderr);

	exit(1);
}

#ifdef __STDC__
int confirm_quit(void)
#else
int confirm_quit()
#endif
{
	WINDOW *quit_window;

	int inputch;

	if (!changed)
		return 1;

	quit_window=newwin(5,70,10,5);

	mybox(quit_window,5,70);

	if (!elm)
	{
		mvwaddstr(quit_window,1,1,"Are you sure you wish to quit?");

		mvwaddstr(quit_window,3,1,"Press Y to quit or N to return to the word processor.");
	}
	else
	{
		mvwaddstr(quit_window,1,1,"Save and return to mailer?");

		mvwaddstr(quit_window,3,1,"Press Y to save file and exit or N to return to the word processor.");
	}

	wrefresh(quit_window);

	inputch=wgetch(quit_window);

	werase(quit_window);

	wrefresh(quit_window);

	delwin(quit_window);

	display_screen();

	switch(inputch)
	{
		case 'Y':
		case 'y':	if (elm)
					write_ascii(filename);

				return 1;

		default:	return 0;
	}
}
