/* main include file for hwp */

#ifdef linux
#include <ncurses.h>
#else
#include <curses.h>
#endif

/* Defines */

/* For Sun's and EP/IX */

/*
extern char *sys_errlist[];
#define strerror(x) (sys_errlist[x])
*/

#define CASE 1
#define NOCASE 2
#define CASE_LEN 3
#define NOCASE_LEN 4

#ifndef UNTABER
#ifndef COHERENT
#define UNTABER "expand"
#else
#define UNTABER "detab"
#endif
#endif

/* filter used with PostScript printers */
#ifndef PSFILTER
# ifdef COHERENT
#  define PSFILTER "prps -b -h"
# else
#  define PSFILTER "asc2ps"
# endif /* COHERENT */
#endif /* PSFILTER */

/* filter used with Epson printers */
#ifndef EPFILTER
# ifdef COHERENT
#  define EPFILTER "epson"
# else
#  define EPFILTER "cat"
# endif /* COHERENT */
#endif /* EPFILTER */

/* spooler that handles dot-matrix (Epson) printers */
#ifndef SPOOLER
# ifdef linux
#  define SPOOLER "lpr"
# else
#  ifdef COHERENT
#   define SPOOLER "lp"
#  else
#   define SPOOLER "lpr -B -c"
#  endif /* COHERENT */
# endif /* linux */
#endif /* SPOOLER */

/* spooler that handles PostScript printers */
#ifndef PSPOOLER
# ifdef linux
#  define PSPOOLER "lpr"
# else
#  ifdef COHERENT
#   define PSPOOLER "lp"
#  else
#   define PSPOOLER "lpr -B -c"
#  endif /* COHERENT */
# endif /* linux */
#endif /* PSPOOLER */

#ifndef SPELLER
#ifdef linux
#define SPELLER "ispell -u"
#else
#define SPELLER "spell"
#endif
#endif

#define LINE_LENGTH 80

#define LINES_PER_PAGE (LINES-3)

#define NORMAL 0x0000

#define START_BOLD 0x0100
#define END_BOLD 0x0200

#define START_SUBSCRIPT 0x0400
#define END_SUBSCRIPT 0x0800

#define START_UNDERLINE 0x1000
#define END_UNDERLINE 0x2000

#define START_SUPERSCRIPT 0x4000
#define END_SUPERSCRIPT 0x8000

#define OVERSTRIKE 1
#define INSERT 2

#ifndef ACS_VLINE
#define ACS_VLINE '|'
#endif

#ifndef ACS_HLINE
#define ACS_HLINE '-'
#endif

#ifndef ACS_ULCORNER
#define ACS_ULCORNER '+'
#endif

#ifndef ACS_LLCORNER
#define ACS_LLCORNER '+'
#endif

#ifndef ACS_LRCORNER
#define ACS_LRCORNER '+'
#endif

#ifndef ACS_URCORNER
#define ACS_URCORNER '+'
#endif

#ifndef linux
#define mybox(win,lines,cols)\
box(win,(ACS_VLINE|A_BOLD),(ACS_HLINE|A_BOLD));\
wattron(win,A_BOLD);\
mvwaddch(win,0,0,ACS_ULCORNER);\
mvwaddch(win,0,cols-1,ACS_URCORNER);\
mvwaddch(win,lines-1,0,ACS_LLCORNER);\
mvwaddch(win,lines-1,cols-1,ACS_LRCORNER);\
wattroff(win,A_BOLD);\
wrefresh(win);
#else
#define mybox(win,lines,cols) box(win,0,0)
#endif

#define GLASS 0
#define MGR 1
#define X11 2

/* Globals */

extern int underline_char;

extern int term_type;

extern char **word_list;

extern int highmark,lowmark;

extern int num_words;

extern int elm;

extern int last_current_x,current_word,last_x,last_y,last_page;

extern int find_type;

extern char search_str[LINE_LENGTH+1],replace_str[LINE_LENGTH+1];

extern short *save_file_buffer;

extern short *file_buffer;

extern short *cut_buffer;

extern int keephighmark,keeplowmark;

extern WINDOW *mystdscr,*textscr;

extern char filename[1024],inputline[LINE_LENGTH+2];

extern int numlines,page_length,tab_size,indent,
	left_margin,right_margin,top_blanks,
	bottom_blanks,starting_page_no,version,
	current_page,current_y,current_x,current_attr,
	insertmode,line_spacing,changed;

extern char header[LINE_LENGTH+1],footer[LINE_LENGTH+1];

/* Forward function declarations */

#ifdef __STDC__
#define __P(args) args
#else
#define __P(args) ()
#endif

extern void init_curses __P((void));

extern void end_curses __P((void));

extern int do_load_file __P((char *input_filename));

extern int do_bring_in_file __P((char *input_filename));

extern int confirm_load __P((void));

extern void get_user_input __P((void));

extern void display_screen __P((void));

extern void my_exit __P((char *message));

extern void write_file __P((void));

extern int get_inputline __P((char *message,char *prompt,char *output));

extern void error_message __P((char *title,char *message));

extern int file_menu __P((void));

extern void do_write_file __P((char *output_filename));

extern void do_write_nrout __P((char *output_filename));

extern void load_file __P((void));

extern void bring_in_file __P((void));

extern int confirm_quit __P((void));

extern int options_menu __P((void));

extern int block_menu __P((void));

extern int do_menubar __P((void));

extern void justify __P((int y_val));

extern void insert __P((short str[LINE_LENGTH],int len,int y_val));

extern void print_file __P((void));

extern int edit_menu __P((void));

extern void write_ascii __P((char *ascii_file));

extern int locate_menu __P((void));

extern int do_search __P((char *string,int case_type,int first));

extern int spell_menu __P((void));

extern void get_spell_list __P((void));

extern void do_help __P((void));

extern int do_replace __P((char *find_str,char *repl_str,int first));

extern int ask_replace_all __P((void));
