#ifdef OLD_ACCESS
#include <access.h>
#else
#include <unistd.h>
#endif

#include <string.h>
#include <stdlib.h>
#include <fcntl.h>

#include "hwp.h"

#ifdef __STDC__
void load_file(void)
#else
void load_file()
#endif
{
	static char input_filename[75]="";

	int retval;

	input_filename[68]=0;

	if (changed)
	{
		if (confirm_load()==0)
			return;
	}

	retval=get_inputline("Filename to load:",input_filename,input_filename);

	if (retval!=1)
	{
		int retval;

		retval=do_load_file(input_filename);

		if (retval==0)
		{
			do_load_file("untitled.hwp");

			error_message("Unable to load:",input_filename);
		}
		else if (retval==-1)
		{
			error_message("Incorrect hwp version:",input_filename);
		}
		else if (retval==-2)
		{
			error_message("Malloc error while loading:","File not loaded.");
		}
	}
}

#ifdef __STDC__
int do_load_file(char *input_filename)
#else
int do_load_file(input_filename)
char *input_filename;
#endif
{
	int current_file_fd,line,pos;

	FILE *current_file;

	if (file_buffer!=NULL)
	{
		free(file_buffer);

		file_buffer=NULL;
	}

#ifdef OLD_ACCESS
	if (!access(input_filename,AEXISTS))
#else
	if (!access(input_filename,F_OK))
#endif
	{
#ifdef OLD_ACCESS
		if (!access(input_filename,AREAD))
#else
		if (!access(input_filename,R_OK))
#endif
		{
			if (strstr(input_filename,".hwp"))
			{
				int setup[25],swap_bytes=0;

				current_file_fd=open(input_filename,O_RDONLY);

				read(current_file_fd,setup,25*sizeof(int));

				/* setup[0] is the version number 
				   - 3 means that the special characters are
				   stored for each key
				   - versions 2 and 1 stored start and stop 
				   keys instead and must be converted
				   - 2 means that the header and footer are 
				   stored within the file 
				   - version 1 did not store them */

				if (setup[0]>3||setup[0]<1)
				{
					int item,p1,p2,p3,p4;

					swap_bytes=1;

					for (item=0;item<25;item++)
					{
						p1=(setup[item]&0xff000000)>>24;
						p2=(setup[item]&0x00ff0000)>>8;
						p3=(setup[item]&0x0000ff00)<<8;
						p4=(setup[item]&0x000000ff)<<24;

						setup[item]=p1|p2|p3|p4;
					}
				}

				if (setup[0]>3||setup[0]<1)
					return -1;
				else if (setup[0]>=2)
				{
					read(current_file_fd,header,LINE_LENGTH+1);
					read(current_file_fd,footer,LINE_LENGTH+1);
				}
				else
				{
					strcpy(header,"%");
					strcpy(footer,"");
				}

				numlines=setup[1];
				page_length=setup[2];
				tab_size=setup[3];
				indent=setup[4];
				left_margin=setup[5];
				right_margin=setup[6];
				if (right_margin>78)
					right_margin=78;
				top_blanks=setup[7];
				bottom_blanks=setup[8];
				starting_page_no=setup[9];
				line_spacing=setup[10];
				current_page=setup[11];
				current_y=setup[12];
				current_x=left_margin;

				file_buffer=(short *) malloc(numlines*LINE_LENGTH*sizeof(short));

				if (file_buffer==NULL)
					return -2;

				memset(file_buffer,0,numlines*LINE_LENGTH*sizeof(short));

				read(current_file_fd,file_buffer,numlines*LINE_LENGTH*sizeof(short));

				close(current_file_fd);

				if (swap_bytes)
				{
					short p1,p2,count;

					for (count=0;count<numlines*LINE_LENGTH;count++)
					{
						p1=(file_buffer[count]&0xff00)>>8;
						p2=(file_buffer[count]&0x00ff)<<8;
						file_buffer[count]=p1|p2;
					}
				}

				if (setup[0]<3)
				{
					for (line=0;line<numlines;line++)
					{
						current_attr=0;

						for (pos=0;pos<LINE_LENGTH;pos++)
						{
							if (file_buffer[line*LINE_LENGTH+pos]&START_BOLD)
								current_attr|=START_BOLD;

							if (file_buffer[line*LINE_LENGTH+pos]&END_BOLD)
								current_attr&=~START_BOLD;

							if (file_buffer[line*LINE_LENGTH+pos]&START_UNDERLINE)
								current_attr|=START_UNDERLINE;

							if (file_buffer[line*LINE_LENGTH+pos]&END_UNDERLINE)
								current_attr&=~START_UNDERLINE;

							if (file_buffer[line*LINE_LENGTH+pos]&START_SUPERSCRIPT)
								current_attr|=START_SUPERSCRIPT;

							if (file_buffer[line*LINE_LENGTH+pos]&END_SUPERSCRIPT)
								current_attr&=~START_SUPERSCRIPT;

							if (file_buffer[line*LINE_LENGTH+pos]&START_SUBSCRIPT)
								current_attr|=START_SUBSCRIPT;

							if (file_buffer[line*LINE_LENGTH+pos]&END_SUBSCRIPT)
								current_attr&=~START_SUBSCRIPT;

							file_buffer[line*LINE_LENGTH+pos]|=current_attr;
						}
					}
				}
			}
			else
			{
				char tmpfilename[65],command[128];

				numlines=0;

				line_spacing=0;

				left_margin=0;

				indent=8;

				right_margin=78;

				top_blanks=bottom_blanks=0;

				current_x=0;

				current_y=0;

				if (!elm)
				{
					strcpy(header,"%");
					strcpy(footer,"");
				}
				else
				{
					strcpy(header,"");
					strcpy(footer,"");
				}

				sprintf(tmpfilename,"/tmp/hwp.%d",getpid());

				sprintf(command,"%s < %s > %s",UNTABER,input_filename,tmpfilename);

				system(command);

				current_file=fopen(tmpfilename,"r");

				while (fgets(inputline,LINE_LENGTH,current_file))
					numlines++;

				rewind(current_file);

				file_buffer=(short *) malloc(numlines*LINE_LENGTH*sizeof(short));

				if (file_buffer==NULL)
				{
					fclose(current_file);

					unlink(tmpfilename);

					return -2;
				}

				memset(file_buffer,0,numlines*LINE_LENGTH*sizeof(short));

				for (line=0;line<numlines;line++)
				{
					char *tmpptr;

					fgets(inputline,LINE_LENGTH,current_file);

					tmpptr=strrchr(inputline,'\n');

					if (tmpptr)
						*tmpptr=0;

					tmpptr=strrchr(inputline,'\r');

					if (tmpptr)
						*tmpptr=0;

				 	for (pos=0;pos<LINE_LENGTH;pos++)
					{
						if (pos<strlen(inputline))
							file_buffer[pos+line*LINE_LENGTH]=(short)inputline[pos];
						else
							file_buffer[pos+line*LINE_LENGTH]=0;
					}
				}

				fclose(current_file);

				unlink(tmpfilename);
			}
		}
	}
	else
	{
		numlines=2;

		current_y=0;

		current_page=1;

		page_length=66;

		tab_size=8;

		indent=16;

		current_x=16;

		left_margin=8;

		right_margin=72;

		line_spacing=1;

		if (!elm)
		{
			top_blanks=5;

			bottom_blanks=5;

			strcpy(header,"%");
			strcpy(footer,"");
		}
		else
		{
			top_blanks=0;

			bottom_blanks=0;

			strcpy(header,"");
			strcpy(footer,"");
		}

		file_buffer=(short *)malloc(numlines*LINE_LENGTH*sizeof(short));

		if (file_buffer==NULL)
			return -2;

		memset(file_buffer,0,((unsigned)numlines*LINE_LENGTH*sizeof(short)));
	}

	strcpy(filename,input_filename);

	changed=0;

	current_attr=A_NORMAL;

	return 1;
}

#ifdef __STDC__
int confirm_load(void)
#else
int confirm_load()
#endif
{
	WINDOW *load_window;

	int inputch;

	if (!changed)
		return 1;

	load_window=newwin(5,70,10,5);

	mybox(load_window,5,70);

	mvwaddstr(load_window,1,1,"The file in the buffer has not yet been saved:");

	mvwaddstr(load_window,3,1,"Press Y to load a new file or N to return to the current file.");

	wrefresh(load_window);

	inputch=wgetch(load_window);

	werase(load_window);

	wrefresh(load_window);

	delwin(load_window);

	display_screen();

	switch(inputch)
	{
		case 'Y':
		case 'y':	return 1;

		default:	return 0;
	}
}
