#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "hwp.h"

#ifdef __STDC__
int locate_menu(void)
#else
int locate_menu()
#endif
{
	WINDOW *locate_win;

	int inputch=0,pos=0;

	static char number_str[LINE_LENGTH+1]="";

	locate_win=newwin(9,25,1,23);

	mybox(locate_win,9,25);

	wattron(locate_win,A_REVERSE);

	mvwaddstr(locate_win,1,1,"Find (case sensitive)");

	wattroff(locate_win,A_REVERSE);

	mvwaddstr(locate_win,2,1,"Find (case insensitive)");

	mvwaddstr(locate_win,3,1,"Find next");

	mvwaddstr(locate_win,4,1,"Search and Replace");

	mvwaddstr(locate_win,5,1,"Replace next");

	mvwaddstr(locate_win,6,1,"Goto line number");

	mvwaddstr(locate_win,7,1,"Goto page number");

	keypad(locate_win,TRUE);

	wmove(locate_win,1,1);

	wrefresh(locate_win);

	while(inputch!='\n'&&inputch!='\r'&&inputch!=27)
	{
		inputch=getch();

		switch(pos)
		{
			case 0:	mvwaddstr(locate_win,1,1,"Find (case sensitive)");

				break;

			case 1:	mvwaddstr(locate_win,2,1,"Find (case insensitive)");

				break;

			case 2:	mvwaddstr(locate_win,3,1,"Find next");

				break;

			case 3:	mvwaddstr(locate_win,4,1,"Search and Replace");

				break;

			case 4:	mvwaddstr(locate_win,5,1,"Replace next");

				break;

			case 5:	mvwaddstr(locate_win,6,1,"Goto line number");

				break;

			case 6:	mvwaddstr(locate_win,7,1,"Goto page number");

				break;
		}

		switch(inputch)
		{
			case 12:	wrefresh(curscr);

					break;

			case KEY_DOWN:	pos++;

					break;

			case KEY_UP:	pos--;

					if(pos<0)
						pos+=7;

					break;

			case KEY_RIGHT:	werase(locate_win);

					wrefresh(locate_win);

					delwin(locate_win);

					display_screen();

					return -1;

			case KEY_LEFT:	werase(locate_win);

					wrefresh(locate_win);

					delwin(locate_win);

					display_screen();

					return -2;
		}

		pos=pos%7;

		wattron(locate_win,A_REVERSE);

		switch(pos)
		{
			case 0:	mvwaddstr(locate_win,1,1,"Find (case sensitive)");
				wmove(locate_win,1,1);

				break;

			case 1:	mvwaddstr(locate_win,2,1,"Find (case insensitive)");
				wmove(locate_win,2,1);

				break;

			case 2:	mvwaddstr(locate_win,3,1,"Find next");
				wmove(locate_win,3,1);

				break;

			case 3:	mvwaddstr(locate_win,4,1,"Search and Replace");
				wmove(locate_win,4,1);

				break;

			case 4:	mvwaddstr(locate_win,5,1,"Replace next");
				wmove(locate_win,5,1);

				break;

			case 5:	mvwaddstr(locate_win,6,1,"Goto line number");
				wmove(locate_win,6,1);

				break;

			case 6:	mvwaddstr(locate_win,7,1,"Goto page number");
				wmove(locate_win,7,1);

				break;
		}

		wattroff(locate_win,A_REVERSE);

		wrefresh(locate_win);
	}

	werase(locate_win);

	wrefresh(locate_win);

	delwin(locate_win);

	display_screen();

	if (inputch==27)
		return 0;

	attron(A_REVERSE);

	mvaddstr(0,0,"                                                                        F1:Help ");

	attroff(A_REVERSE);

	wrefresh(stdscr);

	switch(pos)
	{
		case 0:	if (get_inputline("Enter search string:",search_str,search_str)==-1)
				return 0;

			find_type=CASE;

			do_search(search_str,find_type,1);

			display_screen();

			return 0;

		case 1:	if (get_inputline("Enter search string:",search_str,search_str)==-1)
				return 0;

			find_type=NOCASE;

			do_search(search_str,find_type,1);

			display_screen();

			strcpy(replace_str,"");

			return 0;

		case 2:	if (strlen(search_str)==0)
			{
				error_message("Can't find next because:","You haven't specified a search string yet.");

				return 0;
			}

			do_search(search_str,find_type,0);

			display_screen();

			return 0;

		case 3: if (get_inputline("Enter search string:",search_str,search_str)==-1)
				return 0;

			if (get_inputline("Enter replacement string:",replace_str,replace_str)==-1)
				return 0;

			if (ask_replace_all())
			{
				if (do_replace(search_str,replace_str,1))
					while (do_replace(search_str,replace_str,-1));
			}
			else
				do_replace(search_str,replace_str,1);

			display_screen();

			return 0;

		case 4: if (strlen(replace_str)==0)
			{
				error_message("Can't replace next because:","You haven't specified a search/replace pair yet.");

				return 0;
			}

			do_replace(search_str,replace_str,0);

			display_screen();

			return 0;

		case 5:	if (get_inputline("Enter new line number:",number_str,number_str)==-1)
				return 0;

			current_y=atoi(number_str)-1;

			if (current_y<0)
			{
				error_message("Incorrect line number entered:","Ignored.");

				return 0;
			}

			if (current_y>=numlines)
				current_y=numlines-1;

			current_y+=current_y%(1+line_spacing);

			current_page=current_y/LINES_PER_PAGE+1;

			current_y=(current_y)%LINES_PER_PAGE;

			display_screen();

			return 0;

		case 6:	if (get_inputline("Enter new page number:",number_str,number_str)==-1)
				return 0;

			current_page=atoi(number_str)-1;

			current_y=current_page*(page_length-bottom_blanks-top_blanks);

			current_page=current_y/LINES_PER_PAGE+1;

			current_y=(current_y)%LINES_PER_PAGE;

			display_screen();

			return 0;
	}

	return 0;
}

#ifdef __STDC__
int do_search(char *string,int case_type,int first)
#else
int do_search(string,case_type,first)
char *string;
int case_type,first;
#endif
{
	int line,pos,cont=0,goodpos=0,len;

	char check1,check2;

	len=strlen(string);

	if (!len)
	{
		error_message("No string to find!","Enter a string to find with the Locate menu.");

		return 0;
	}

	if (case_type==NOCASE||case_type==NOCASE_LEN)
	{
		for (pos=0;pos<len;pos++)
		{
			if (isupper(string[pos]))
				string[pos]=tolower(string[pos]);
		}
	}

	pos=current_x+1;

	for (line=current_y+(current_page-1)*LINES_PER_PAGE;line<numlines;line++)
	{
		cont=0;

		for (;pos<LINE_LENGTH;pos++)
		{
			check1=file_buffer[line*LINE_LENGTH+pos]&0xff;
			check2=file_buffer[line*LINE_LENGTH+pos-1]&0xff;

			if (case_type==CASE)
			{
				if (string[cont]==check1)
				{
					if (cont==0)
						goodpos=pos;
	
					cont++;
				}
				else
					cont=0;

				if (cont>=len)
					break;
			}
			else if (case_type==CASE_LEN)
			{
				if (cont==0&&isalpha(check2))
					cont=0;
				else
				if (cont==len&&isalpha(check1))
					cont=0;
				else if (cont!=len)
				{
					if (string[cont]==check1)
					{
						if (cont==0)
							goodpos=pos;
	
						cont++;
					}
					else
						cont=0;
				}
				else 
					cont++;

				if (cont>len)
					break;
			}
			else if (case_type==NOCASE)
			{
				char tmpch;

				if (isupper(check1))
					tmpch=tolower(check1);
				else
					tmpch=check1;

				if (string[cont]==tmpch)
				{
					if (cont==0)
						goodpos=pos;
	
					cont++;
				}
				else
					cont=0;

				if (cont>=len)
					break;
			}
			else if (case_type==NOCASE_LEN)
			{
				char tmpch;

				if (isupper(check1))
					tmpch=tolower(check1);
				else
					tmpch=check1;

				if (cont==0&&isalpha(check2))
					cont=0;
				else
				if (cont==len&&isalpha(check1))
					cont=0;
				else if (cont!=len)
				{
					if (string[cont]==tmpch)
					{
						if (cont==0)
							goodpos=pos;
		
						cont++;
					}
					else
						cont=0;
				}
				else
					cont++;

				if (cont>len)
					break;
			}
		}

		pos=0;

		if (cont>=len)
			break;
	}

	if (cont>=len)
	{
		current_x=goodpos;

		current_y=line%LINES_PER_PAGE;

		current_page=line/LINES_PER_PAGE+1;

		return 1;
	}

	for (line=0;line<current_y+(current_page-1)*LINES_PER_PAGE;line++)
	{
		cont=0;

		for (pos=0;pos<LINE_LENGTH;pos++)
		{
			check1=file_buffer[line*LINE_LENGTH+pos]&0xff;
			check2=file_buffer[line*LINE_LENGTH+pos-1]&0xff;

			if (case_type==CASE)
			{
				if (string[cont]==check1)
				{
					if (cont==0)
						goodpos=pos;
	
					cont++;
				}
				else
					cont=0;

				if (cont>=len)
					break;
			}
			else if (case_type==CASE_LEN)
			{
				if (cont==0&&isalpha(check2))
					cont=0;
				else
				if (cont==len&&isalpha(check1))
					cont=0;
				else if (cont!=len)
				{
					if (string[cont]==check1)
					{
						if (cont==0)
							goodpos=pos;
		
						cont++;
					}
					else
						cont=0;
				}
				else
					cont++;

				if (cont>len)
					break;
			}
			else if (case_type==NOCASE)
			{
				char tmpch;

				if (isupper(check1))
					tmpch=tolower(check1);
				else
					tmpch=check1;

				if (string[cont]==tmpch)
				{
					if (cont==0)
						goodpos=pos;
	
					cont++;
				}
				else
					cont=0;

				if (cont>=len)
					break;
			}
			else if (case_type==NOCASE_LEN)
			{
				char tmpch;

				if (isupper(check1))
					tmpch=tolower(check1);
				else
					tmpch=check1;

				if (cont==0&&isalpha(check2))
					cont=0;
				else
				if (cont==len&&isalpha(check1))
					cont=0;
				else if (cont!=len)
				{
					if (string[cont]==tmpch)
					{
						if (cont==0)
							goodpos=pos;
		
						cont++;
					}
					else
						cont=0;
				}
				else
					cont++;

				if (cont>len)
					break;
			}
		}

		pos=0;

		if (cont>=len)
			break;
	}

	if (cont>=len)
	{
		current_x=goodpos;

		current_y=line%LINES_PER_PAGE;

		current_page=line/LINES_PER_PAGE+1;

		return 1;
	}
	else
	{
		if (first>0)
			error_message("Couldn't find pattern because:","It isn't present in this file.");
		else if (first==0)
			error_message("Couldn't find pattern because:","There aren't any more instances in this file.");

		return 0;
	}

	return 0;
}

#ifdef __STDC__
int do_replace(char *find_str,char *repl_str,int first)
#else
int do_replace(find_str,repl_str,first)
char *find_str,*repl_str;
int first;
#endif
{
	int ret_val,len,pos;

	short repl_attr,replacement[LINE_LENGTH];

	ret_val=do_search(find_str,CASE_LEN,first);

	if (ret_val==0)
		return 0;

	repl_attr=file_buffer[(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH+current_x]&0xff00;

	pos=current_x;

	while (((char)file_buffer[(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH+pos])!=' '&&((char)file_buffer[(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH+pos])!=0&&pos<=78)
		pos++;

	len=pos-current_x;

	for (pos=0;pos<strlen(repl_str);pos++)
	{
		replacement[pos]=((short)repl_str[pos])|repl_attr;
	}

	for (pos=current_x;pos<78-len;pos++)
	{
		file_buffer[(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH+pos]=file_buffer[(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH+pos+len];
	}

	for (pos=78;pos>=78-len;pos--)
	{
		file_buffer[(current_y+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH+pos]=0;
	}

	insert(replacement,strlen(repl_str),current_y);

	justify(current_y);

	changed++;

	return 1;
}

#ifdef __STDC__
int ask_replace_all(void)
#else
int ask_replace_all()
#endif
{
	WINDOW *replace_window;

	int inputch;

	replace_window=newwin(5,70,10,5);

	mybox(replace_window,5,70);

	mvwaddstr(replace_window,1,1,"Do you want to replace all occurances?");

	mvwaddstr(replace_window,3,1,"Press Y to replace all or N to replace the first occurance.");

	wrefresh(replace_window);

	inputch=wgetch(replace_window);

	werase(replace_window);

	wrefresh(replace_window);

	delwin(replace_window);

	display_screen();

	switch(inputch)
	{
		case 'Y':
		case 'y':	return 1;

		default:	return 0;
	}
}
