#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "hwp.h"

#ifdef __STDC__
void print_file(void)
#else
void print_file()
#endif
{
	char prn_file[65],tempstr1[LINE_LENGTH+1],tempstr2[LINE_LENGTH+1];

	FILE *prn_fd;

	int line=0,page=starting_page_no,counter,bold_on=0,underline_on=0,pos,superscript_on=0,subscript_on=0;

	sprintf(prn_file,"/tmp/hwpprn.%d",getpid());

	errno=0;

	prn_fd=fopen(prn_file,"w");

	if (prn_fd==NULL)
	{
		error_message("Couldn't open temporary print file because:",strerror(errno));

		return;
	}

	fprintf(prn_fd,"%c%c",27,'n');

	while(line<numlines)
	{
		memset(tempstr1,0,((unsigned)LINE_LENGTH));

		tempstr1[LINE_LENGTH]=0;

		if (strcspn(header,"%"))
			strncpy(tempstr1,header,strcspn(header,"%"));

		if (strchr(header,'%'))
		{
			sprintf(tempstr2,"%d",page);

			strcat(tempstr1,tempstr2);

			strcat(tempstr1,strchr(header,'%')+1);
		}

		memset(tempstr2,' ',((unsigned)LINE_LENGTH));

		tempstr2[LINE_LENGTH]=0;

		strcpy(tempstr2+LINE_LENGTH-strlen(tempstr1),tempstr1);
		strcat(tempstr2,"\n");

		if (top_blanks<3)
		{
			fputs(tempstr2,prn_fd);

			for (counter=1;counter<top_blanks;counter++)
				fputc('\n',prn_fd);
		}
		else
		{
			fputc('\n',prn_fd);

			fputs(tempstr2,prn_fd);

			for (counter=2;counter<top_blanks;counter++)
				fputc('\n',prn_fd);
		}

		if (underline_on)
		{
			fprintf(prn_fd,"%c%c%c",27,'-',1);
		}

		if (bold_on)
		{
			fprintf(prn_fd,"%c%c",27,'E');
		}

		if (superscript_on)
		{
			fprintf(prn_fd,"%c%c%c%c%c",27,'P',27,'S',0);
		}

		if (subscript_on)
		{
			fprintf(prn_fd,"%c%c%c%c%c",27,'P',27,'S',1);
		}

		for (counter=0;counter<page_length-top_blanks-bottom_blanks&&line<numlines;counter++)
		{
			for (pos=0;pos<LINE_LENGTH;pos++)
			{
				if (!underline_on)
				{
					if (file_buffer[pos+line*LINE_LENGTH]&START_UNDERLINE)
					{
						underline_on=1;
	
						fprintf(prn_fd,"%c%c%c",27,'-',1);
					}
				}
				else
				{
					if (!(file_buffer[pos+line*LINE_LENGTH]&START_UNDERLINE))
					{
						underline_on=0;
	
						fprintf(prn_fd,"%c%c%c",27,'-',0);
					}
				}

				if (!bold_on)
				{
					if (file_buffer[pos+line*LINE_LENGTH]&START_BOLD)
					{
						bold_on=1;
	
						fprintf(prn_fd,"%c%c",27,'E');
					}
				}
				else
				{
					if (!(file_buffer[pos+line*LINE_LENGTH]&START_BOLD))
					{
						bold_on=0;
	
						fprintf(prn_fd,"%c%c",27,'F');
					}
				}

				if (!superscript_on)
				{
					if (file_buffer[pos+line*LINE_LENGTH]&START_SUPERSCRIPT)
					{
						superscript_on=1;
	
						fprintf(prn_fd,"%c%c%c%c%c",27,'P',27,'S',0);
					}
				}
				else
				{
					if (!(file_buffer[pos+line*LINE_LENGTH]&START_SUPERSCRIPT))
					{
						superscript_on=0;
	
						fprintf(prn_fd,"%c%c%c%c",27,'n',27,'T');
					}
				}

				if (!subscript_on)
				{
					if (file_buffer[pos+line*LINE_LENGTH]&START_SUBSCRIPT)
					{
						subscript_on=1;
	
						fprintf(prn_fd,"%c%c%c%c%c",27,'P',27,'S',1);
					}
				}
				else
				{
					if (!(file_buffer[pos+line*LINE_LENGTH]&START_SUBSCRIPT))
					{
						subscript_on=0;
	
						fprintf(prn_fd,"%c%c%c%c",27,'n',27,'T');
					}
				}

				if (file_buffer[pos+line*LINE_LENGTH])
					fputc(file_buffer[pos+line*LINE_LENGTH],prn_fd);
				else
					fputc(' ',prn_fd);
			}

			fputc('\n',prn_fd);

			line++;
		}

		if (underline_on)
		{
			fprintf(prn_fd,"%c%c%c",27,'-',0);
		}

		if (bold_on)
		{
			fprintf(prn_fd,"%c%c",27,'F');
		}

		if (superscript_on)
		{
			fprintf(prn_fd,"%c%c%c%c",27,'n',27,'T');
		}

		if (subscript_on)
		{
			fprintf(prn_fd,"%c%c%c%c",27,'n',27,'T');
		}

		if (line>=numlines)
			for (;counter<page_length-top_blanks-bottom_blanks;counter++)
				fputc('\n',prn_fd);

		memset(tempstr1,0,((unsigned)LINE_LENGTH));

		tempstr1[LINE_LENGTH]=0;

		if (strcspn(footer,"%"))
			strncpy(tempstr1,footer,strcspn(footer,"%"));

		if (strchr(footer,'%'))
		{
			sprintf(tempstr2,"%d",page);

			strcat(tempstr1,tempstr2);

			strcat(tempstr1,strchr(footer,'%')+1);
		}

		memset(tempstr2,' ',((unsigned)LINE_LENGTH));

		tempstr2[LINE_LENGTH]=0;

		strcpy(tempstr2+LINE_LENGTH-strlen(tempstr1),tempstr1);
		strcat(tempstr2,"\n");

		if (bottom_blanks<3)
		{
			for (counter=1;counter<bottom_blanks;counter++)
				fputc('\n',prn_fd);

			fputs(tempstr2,prn_fd);
		}
		else
		{
			for (counter=2;counter<bottom_blanks;counter++)
				fputc('\n',prn_fd);

			fputs(tempstr2,prn_fd);

			fputc('\n',prn_fd);
		}

		fflush(prn_fd);

		page++;
	}

	fclose(prn_fd);

	sprintf(tempstr1,"%s %s | %s", EPFILTER, prn_file, SPOOLER);

	system(tempstr1);

	unlink(prn_file);

	clearok(mystdscr,TRUE);

	refresh();

	clearok(textscr,TRUE);

	wrefresh(textscr);
}

#ifdef __STDC__
void do_write_nrout(char *output_filename)
#else
void do_write_nrout(output_filename)
char *output_filename;
#endif
{
	char prn_file[65],tempstr1[LINE_LENGTH+1],tempstr2[LINE_LENGTH+1];

	FILE *prn_fd;

	int line=0,page=starting_page_no,counter,bold_on=0,underline_on=0,pos,superscript_on=0,subscript_on=0;

	errno=0;

	if (strstr(output_filename,".ps"))
		sprintf(prn_file,"/tmp/hwpps%d",getpid());
	else
		strcpy(prn_file,output_filename);

	prn_fd=fopen(prn_file,"w");

	if (prn_fd==NULL)
	{
		error_message("Couldn't open output file because:",strerror(errno));

		return;
	}

	while(line<numlines)
	{
		memset(tempstr1,0,((unsigned)LINE_LENGTH));

		tempstr1[LINE_LENGTH]=0;

		if (strcspn(header,"%"))
			strncpy(tempstr1,header,strcspn(header,"%"));

		if (strchr(header,'%'))
		{
			sprintf(tempstr2,"%d",page);

			strcat(tempstr1,tempstr2);

			strcat(tempstr1,strchr(header,'%')+1);
		}

		memset(tempstr2,' ',((unsigned)LINE_LENGTH));

		tempstr2[LINE_LENGTH]=0;

		strcpy(tempstr2+LINE_LENGTH-strlen(tempstr1),tempstr1);
		strcat(tempstr2,"\n");

		if (top_blanks<3)
		{
			fputs(tempstr2,prn_fd);

			for (counter=1;counter<top_blanks;counter++)
				fputc('\n',prn_fd);
		}
		else
		{
			fputc('\n',prn_fd);

			fputs(tempstr2,prn_fd);

			for (counter=2;counter<top_blanks;counter++)
				fputc('\n',prn_fd);
		}

		for (counter=0;counter<page_length-top_blanks-bottom_blanks&&line<numlines;counter++)
		{
			for (pos=0;pos<LINE_LENGTH;pos++)
			{
				if (file_buffer[pos+line*LINE_LENGTH]&START_UNDERLINE)
				{
					underline_on++;
				}
				else
					underline_on=0;

				if (file_buffer[pos+line*LINE_LENGTH]&START_BOLD)
				{
					bold_on++;
				}
				else
					bold_on=0;

				if (file_buffer[pos+line*LINE_LENGTH]&START_SUPERSCRIPT)
				{
					superscript_on++;
				}
				else
					superscript_on=0;

				if (file_buffer[pos+line*LINE_LENGTH]&START_SUBSCRIPT)
				{
					subscript_on++;
				}
				else
					subscript_on=0;

				if (underline_on)
					fprintf(prn_fd,"_\b");

				if (file_buffer[pos+line*LINE_LENGTH])
					fputc(file_buffer[pos+line*LINE_LENGTH],prn_fd);
				else
					fputc(' ',prn_fd);

				if (bold_on)
				{
					fputc('\b',prn_fd);

					if (file_buffer[pos+line*LINE_LENGTH]) 
						fputc(file_buffer[pos+line*LINE_LENGTH],prn_fd); 
					else 
						fputc(' ',prn_fd); 
				} 
			}

			fputc('\n',prn_fd); 

			line++;
		}

		if (line>=numlines)
			for (;counter<page_length-top_blanks-bottom_blanks;counter++)
				fputc('\n',prn_fd);

		memset(tempstr1,0,((unsigned)LINE_LENGTH));

		tempstr1[LINE_LENGTH]=0;

		if (strcspn(footer,"%"))
			strncpy(tempstr1,footer,strcspn(footer,"%"));

		if (strchr(footer,'%'))
		{
			sprintf(tempstr2,"%d",page);

			strcat(tempstr1,tempstr2);

			strcat(tempstr1,strchr(footer,'%')+1);
		}

		memset(tempstr2,' ',((unsigned)LINE_LENGTH));

		tempstr2[LINE_LENGTH]=0;

		strcpy(tempstr2+LINE_LENGTH-strlen(tempstr1),tempstr1);
		strcat(tempstr2,"\n");

		if (bottom_blanks<3)
		{
			for (counter=1;counter<bottom_blanks;counter++)
				fputc('\n',prn_fd);

			fputs(tempstr2,prn_fd);
		}
		else
		{
			for (counter=2;counter<bottom_blanks;counter++)
				fputc('\n',prn_fd);

			fputs(tempstr2,prn_fd);

			fputc('\n',prn_fd);
		}

		fflush(prn_fd);

		page++;
	}

	fclose(prn_fd);

	if (strstr(output_filename,".ps"))
	{
		if (!strcmp(output_filename,"SPOOLER .ps"))
			sprintf(tempstr1,"%s %s | %s",PSFILTER,prn_file,PSPOOLER);
		else
			sprintf(tempstr1,"%s %s > %s",PSFILTER,prn_file,output_filename);

		system(tempstr1);

		unlink(prn_file);

		clearok(mystdscr,TRUE);

		refresh();
	}

	clearok(textscr,TRUE);

	wrefresh(textscr);
}
