#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include "hwp.h"

#ifdef __STDC__
int spell_menu(void)
#else
int spell_menu()
#endif
{
	WINDOW *spell_win;

	int inputch=0,pos=0;

	spell_win=newwin(5,21,1,49);

	mybox(spell_win,5,21);

	wattron(spell_win,A_REVERSE);

	mvwaddstr(spell_win,1,1,"Check Spelling");

	wattroff(spell_win,A_REVERSE);

	mvwaddstr(spell_win,2,1,"Next incorrect word");

	mvwaddstr(spell_win,3,1,"Skip current word");

	keypad(spell_win,TRUE);

	wmove(spell_win,1,1);

	wrefresh(spell_win);

	while(inputch!='\n'&&inputch!='\r'&&inputch!=27)
	{
		inputch=getch();

		switch(pos)
		{
			case 0:	mvwaddstr(spell_win,1,1,"Check Spelling");

				break;

			case 1:	mvwaddstr(spell_win,2,1,"Next incorrect word");

				break;

			case 2:	mvwaddstr(spell_win,3,1,"Skip current word");

				break;
		}

		switch(inputch)
		{
			case 12:	wrefresh(curscr);

					break;

			case KEY_DOWN:	pos++;

					break;

			case KEY_UP:	pos--;

					if(pos<0)
						pos+=3;

					break;

			case KEY_RIGHT:	werase(spell_win);

					wrefresh(spell_win);

					delwin(spell_win);

					display_screen();

					return -1;

			case KEY_LEFT:	werase(spell_win);

					wrefresh(spell_win);

					delwin(spell_win);

					display_screen();

					return -2;
		}

		pos=pos%3;

		wattron(spell_win,A_REVERSE);

		switch(pos)
		{
			case 0:	mvwaddstr(spell_win,1,1,"Check Spelling");
				wmove(spell_win,1,1);

				break;

			case 1:	mvwaddstr(spell_win,2,1,"Next incorrect word");
				wmove(spell_win,2,1);

				break;

			case 2:	mvwaddstr(spell_win,3,1,"Skip current word");
				wmove(spell_win,3,1);

				break;
		}

		wattroff(spell_win,A_REVERSE);

		wrefresh(spell_win);
	}

	werase(spell_win);

	wrefresh(spell_win);

	delwin(spell_win);

	display_screen();

	if (inputch==27)
		return 0;

	attron(A_REVERSE);

	mvaddstr(0,0,"                                                                        F1:Help ");

	attroff(A_REVERSE);

	wrefresh(stdscr);

	switch(pos)
	{
		case 0:	get_spell_list();

			last_page=last_x=last_y=-1;

			if (num_words==-1)
				return 0;

			if (num_words==0)
			{
				error_message("No words to check because:","There are no words to check.");

				return 0;
			}

			current_word=0;

			last_current_x=current_x;
			current_x=left_margin-1;

			while (do_search(word_list[current_word],CASE_LEN,-1)==0)
			{
				current_word++;

				last_current_x=current_x;
				current_x=left_margin-1;

				if (current_word>=num_words)
				{
					error_message("No words to check because:","All words are spelled correctly.");

					return 0;
				}
			}

			display_screen();

			return 0;

		case 2: current_word++;

			last_page=last_x=last_y=-1;

			last_current_x=current_x;
			current_x=left_margin-1;

		case 1:	if (num_words<0)
			{
#if 0
				current_x=last_current_x;
#endif
				error_message("Can't get next incorrect word because:","You haven't checked the spelling yet.");

				return 0;
			}

			if (current_word>=num_words)
			{
				current_x=last_current_x;
				error_message("Can't get next incorrect word because:","All words have been checked.");

				return 0;
			}

			while (1)
			{
				if (do_search(word_list[current_word],CASE_LEN,-1)==0)
				{
					current_word++;

					last_current_x=current_x;
					current_x=left_margin-1;

					last_page=last_x=last_y=-1;

					if (current_word>=num_words)
					{
						current_x=last_current_x;
						error_message("Can't get next incorrect word because:","All words have been checked.");
	
						return 0;
					}
				}
				else
				{
					if (last_x==-1)
					{
						last_x=current_x;
		
						last_y=current_y;
		
						last_page=current_page;

						break;
					}
					else if (last_x==current_x&&last_y==current_y&&last_page==current_page)
					{
						last_page=last_x=last_y=-1;

						current_word++;

						last_current_x=current_x;
						current_x=left_margin-1;

						if (current_word>=num_words)
						{
							current_x=last_current_x;
							error_message("Can't get next incorrect word because:","All words have been checked.");
		
							return 0;
						}
					}
					else
						break;
				}
			}

			display_screen();

			return 0;
	}

	return 0;
}

#ifdef __STDC__
void get_spell_list(void)
#else
void get_spell_list()
#endif
{
	FILE *spell_fd;

	int line=0,counter,pos;

	char spell_file1[65],spell_file2[65],command[65],inputline[LINE_LENGTH+1];

	if (word_list!=NULL)
	{
		for (counter=0;counter<num_words;counter++)
			free(word_list[counter]);

		free(word_list);

		word_list=NULL;

		num_words=-1;
	}

	sprintf(spell_file1,"/tmp/hwpsp1.%d",getpid());
	sprintf(spell_file2,"/tmp/hwpsp2.%d",getpid());

	errno=0;

	spell_fd=fopen(spell_file1,"w");

	if (spell_fd==NULL)
	{
		error_message("Couldn't open temporary spell checking file because:",strerror(errno));

		return;
	}

	for (line=0;line<numlines;line++)
	{
		for (pos=0;pos<LINE_LENGTH;pos++)
		{
			char check;

			check=file_buffer[pos+line*LINE_LENGTH]&0xff;

			if (check)
				fputc(file_buffer[pos+line*LINE_LENGTH],spell_fd);
			else
				fputc(' ',spell_fd);
		}

		fputc('\n',spell_fd);
	}

	fflush(spell_fd);

	fclose(spell_fd);

	sprintf(command,"%s %s > %s",SPELLER,spell_file1,spell_file2);

	system(command);

	unlink(spell_file1);

	errno=0;

	spell_fd=fopen(spell_file2,"r");

	if (spell_fd==NULL)
	{
		error_message("Couldn't open temporary spell checking file because:",strerror(errno));

		return;
	}

	num_words=0;

	while (fgets(inputline,LINE_LENGTH+1,spell_fd))
		num_words++;

	rewind(spell_fd);

	word_list=(char **) malloc(num_words*sizeof(char *));

	if (file_buffer==NULL)
	{
		error_message("Couldn't spell check because:","Malloc error on word list.");

		num_words=-1;

		return;
	}

	for (line=0;line<num_words;line++)
	{
		char *tmpptr;

		fgets(inputline,LINE_LENGTH+1,spell_fd);

		tmpptr=strrchr(inputline,'\n');

		if (tmpptr)
			*tmpptr=0;

		tmpptr=strrchr(inputline,'\r');

		if (tmpptr)
			*tmpptr=0;

		word_list[line]=(char *)malloc(strlen(inputline)+1);

		if (word_list[line]==NULL)
		{
			error_message("Couldn't spell check because:","Malloc error on word in word list.");
	
			num_words=-1;
	
			return;
		}

		strcpy(word_list[line],inputline);
	}

	fclose(spell_fd);

	unlink(spell_file2);
}
