#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

#include "hwp.h"

#ifdef __STDC__
void write_file(void)
#else
void write_file()
#endif
{
	static char output_filename[75]="";

	int retval;

	output_filename[68]=0;

	if (strstr(filename,".hwp")||elm)
		strcpy(output_filename,filename);

	retval=get_inputline("Filename to write (.hwp for hwp file, .out: for nroff-style more      output, .ps for Postscript, ASCII text is the default):",output_filename,output_filename);

	if (retval!=-1)
	{
		if (strstr(output_filename,".hwp"))
			do_write_file(output_filename);
		else if (strstr(output_filename,".out")||strstr(output_filename,".ps"))
			do_write_nrout(output_filename);
		else
			write_ascii(output_filename);
	}
}

#ifdef __STDC__
void do_write_file(char *output_filename)
#else
void do_write_file(output_filename)
char *output_filename;
#endif
{
	int write_fd,pad;

	errno=0;

	if (strlen(output_filename)>5)
	{
		if (strcmp(output_filename+strlen(output_filename)-4,".hwp"))
			strcat(output_filename,".hwp");
	}
	else
		strcat(output_filename,".hwp");

	write_fd=open(output_filename,O_WRONLY|O_CREAT,0666);

	if (write_fd==-1)
	{
		error_message("Couldn't write file because:",strerror(errno));

		return;
	}

	write(write_fd,&version,sizeof(int));
	write(write_fd,&numlines,sizeof(int));
	write(write_fd,&page_length,sizeof(int));
	write(write_fd,&tab_size,sizeof(int));
	write(write_fd,&indent,sizeof(int));
	write(write_fd,&left_margin,sizeof(int));
	write(write_fd,&right_margin,sizeof(int));
	write(write_fd,&top_blanks,sizeof(int));
	write(write_fd,&bottom_blanks,sizeof(int));
	write(write_fd,&starting_page_no,sizeof(int));
	write(write_fd,&line_spacing,sizeof(int));
	write(write_fd,&current_page,sizeof(int));
	write(write_fd,&current_y,sizeof(int));

	for (pad=0;pad<12;pad++)
		write(write_fd,0,sizeof(int));

	write(write_fd,header,LINE_LENGTH+1);
	write(write_fd,footer,LINE_LENGTH+1);

	write(write_fd,file_buffer,numlines*LINE_LENGTH*sizeof(short));

	close(write_fd);

	strcpy(filename,output_filename);

	changed=0;
}

#ifdef __STDC__
void write_ascii(char *ascii_file)
#else
void write_ascii(ascii_file)
char *ascii_file;
#endif
{
	char tempstr1[LINE_LENGTH+1],tempstr2[LINE_LENGTH+1];

	FILE *ascii_fd;

	int line=0,page=starting_page_no,counter,pos;

	errno=0;

	ascii_fd=fopen(ascii_file,"w");

	if (ascii_fd==NULL)
	{
		error_message("Couldn't open ASCII file because:",strerror(errno));

		return;
	}

	while(line<numlines)
	{
		if (!elm)
		{
			memset(tempstr1,0,((unsigned)LINE_LENGTH));

			tempstr1[LINE_LENGTH]=0;

			if (strcspn(header,"%"))
				strncpy(tempstr1,header,strcspn(header,"%"));
	
			if (strchr(header,'%'))
			{
				sprintf(tempstr2,"%d",page);
	
				strcat(tempstr1,tempstr2);
	
				strcat(tempstr1,strchr(header,'%')+1);
			}

			memset(tempstr2,' ',((unsigned)LINE_LENGTH));

			tempstr2[LINE_LENGTH]=0;

			strcpy(tempstr2+LINE_LENGTH-strlen(tempstr1),tempstr1);
			strcat(tempstr2,"\n");

			fputs(tempstr2,ascii_fd);

			for (counter=1;counter<top_blanks;counter++)
				fputc('\n',ascii_fd);
		}

		for (counter=0;counter<page_length-top_blanks-bottom_blanks&&line<numlines;counter++)
		{
			for (pos=0;pos<LINE_LENGTH;pos++)
			{
				if (file_buffer[pos+line*LINE_LENGTH])
					fputc(file_buffer[pos+line*LINE_LENGTH],ascii_fd);
				else
				{
					int counter;

					for (counter=pos;counter<LINE_LENGTH;counter++)
					{
						if (((char)file_buffer[counter+line*LINE_LENGTH])&&((char)file_buffer[counter+line*LINE_LENGTH])!=' ')
							break;
					}

					if (counter>=LINE_LENGTH)
						break;

					fputc(' ',ascii_fd);
				}
			}

			fputc('\n',ascii_fd);

			line++;
		}

		if (!elm)
		{
			if (line>=numlines)
				for (;counter<page_length-top_blanks-bottom_blanks;counter++)
					fputc('\n',ascii_fd);

			for (counter=1;counter<bottom_blanks;counter++)
				fputc('\n',ascii_fd);
	
			memset(tempstr1,0,((unsigned)LINE_LENGTH));
	
			tempstr1[LINE_LENGTH]=0;
	
			if (strcspn(footer,"%"))
				strncpy(tempstr1,footer,strcspn(footer,"%"));
	
			if (strchr(footer,'%'))
			{
				sprintf(tempstr2,"%d",page);
	
				strcat(tempstr1,tempstr2);
	
				strcat(tempstr1,strchr(footer,'%')+1);
			}
	
			memset(tempstr2,' ',((unsigned)LINE_LENGTH));
	
			tempstr2[LINE_LENGTH]=0;
	
			strcpy(tempstr2+LINE_LENGTH-strlen(tempstr1),tempstr1);
			strcat(tempstr2,"\n");
	
			fputs(tempstr2,ascii_fd);
		}

		fflush(ascii_fd);

		page++;
	}

	fclose(ascii_fd);
}
